;даже как работает оригинал, не понятно
;а работает или не эта прога - вообще неясно.

; ───────────────────────────────────────────────────────────────────────────
; Processor:        K1801VM1
; Target assembler: BK Turbo8 Cross Assembler

;Системные ячейки монитора БК
;Системные признаки DMBK (SYSPR )
PRCW =          40      ; Признак цветного режима (формат 32)
PRINF =         41      ; Признак инверсии фона
PRRP =          42      ; Признак расширенной памяти
PRRUS =         43      ; Признак русского регистра
PRPODC =        44      ; Признак подчёркивания символа
PRINWS =        45      ; Признак инверсии символа
PRISU =         46      ; Признак индикации су
PRBLR =         47      ; Признак блокировки редактирования
PRGRAF =        50      ; Признак графического режима
PRZAP =         51      ; Признак режима записи
PRSTIR =        52      ; Признак режима стирания
PRCWSS =        53      ; Признак цветного режима в служебной строке(СС)
PRPSSS =        54      ; Признак подчёркивания символа в СС
PRISSS =        55      ; Признак инверсии символа в СС
PRGAHK =        56      ; Признак гашения курсора
;Переменные драйвера клавиатуры ( DLLAW )
BUFKL =         104     ; Буфер клавиатуры
PRZKB =         105     ; Признак записи кода в буфер
BKPOWT =        106     ; Буфер константы повтора (t паузы)
PRPOWT =        110     ; Признак повтора кода
SCTAB =         111     ; Счётчик табуляции
MTAB =          112     ; Маска табуляции
SCKLC =         122     ; Счётчик ключа
TAKLC =         124     ; Текущий адрес ключа
;Переменные драйвера ТВ-монитора ( DTWMN )
PRNRUL =        152     ; Признак нарушения рулона
PRZTCK =        153     ; Признак записи точки
MASPGT =        154     ; Маска позиции графической точки (ГТ)
NMPGT =         155     ; Начальная маска позиции ГТ
NOMSIM =        156     ; Номер символа на экране
AS =            160     ; Адрес символа
DSIMB =         162     ; Длина символа в байтах
KSVP =          164     ; Количество символов на экране
AGTVP =         166     ; Адрес (номер) ГТ на экране
AGT =           170     ; Адрес ГТ
DGW =           172     ; Длина графического вектора
SCTVS =         174     ; Счётчик ТВ-строк
BUFX =          176     ; Буфер координаты X
BUFY =          200     ; Буфер координаты Y
ANVP =          202     ; Адрес начала видеопамяти
BAZVP =         204     ; База видеопамяти
DVPB =          206     ; Длина видеопамяти в байтах
DGPB =          210     ; Длина графической памяти в байтах
FON =           212     ; Фон экрана
MASCW =         214     ; Маска цвета
FONSS =         216     ; Фон служебной строки (СС)
MSWSS =         220     ; Маска цвета СС
SCKOD =         222     ; Счётчик кодов
SCUIND =        224     ; Счётчик установки индикаторов
;Переменные драйвера магнитофона ( DMAG )
BPDMAG =        320     ; Блок параметров DMAG


;Переменные, буфера и константы
VERS   = 120004 ;Версия Системы 3.15
BLK    = 120006 ;Адрес блока параметров диска
SUBTEK = 120010 ;Номер подкаталога на текущем диске
SUBOLD = 120011 ;Подкаталог в другой панели
DEVTEK = 120012 ;Номер текущего устройства
SUBDIR = 120013 ;Подкаталог для CREATE, временный
DIR    = 120014 ;Адрес буфера чтения каталога
TSTEP  = 120070 ;Задержка шага головки дисковода
PANEL  = 120072 ;Байты устройств в панелях "MC"
SCREEN = 120074 ;Ячейка перехвата вывода сообщений системы, адрес подпрограммы
                ;обращения вместо EMT16. Для запрета вывода - адрес ближайшей
                ;команды RTS PC
STEK   = 120076 ;Адрес стека перехватчика ЕМТ36
USER   = 120100 ;Значение 1  Адреса  и  значения
       ; 120102 ;Адрес 1     трех ячеек, восста-
       ; 120104 ;Значение 2  навливаемых  систе-
       ; 120106 ;Адрес 2     мой после  ЕМТ14  и
       ; 120110 ;Значение 3  перезапуска
       ; 120112 ;Адрес 3
USER2  = 120114 ;Адрес подпрограммы перед запуском "MC" или 0
NONDOS = 120116 ;Адрес подпрограммы имитации ЕМТ36 для не DOS дисков, или 0
                ;(вывод сообщения Non DOS Disk)
OVERWR = 120124 ;Признак AutoOwerwrite, 1-выкл.
PRED   = 120125 ;Признак Predelete, 1-выкл.
FLOP   = 120126 ;Дисковод:  0 - 40, 1 - 80 track
PALET  = 120127 ;Палитра БК11(М),оцветнение БК10
SY     = 120130 ;Диск загрузки системы (@:)
DK     = 120131 ;Привод для оверлеев (!:)
SORTIR = 120132 ;Режимы сортировки на панелях MC
LD0    = 120134 ;Смещение к логическому диску (в блоках), 0 - корень
LD1    = 120136 ;то же, но для текущей операции
LD2    = 120140 ;Смещение для другой панели MC
NAM    =    306 ;Адрес блока параметров EMT36
BLOK   =    314 ;Номер блока загруженного файла
SIZE   =    316 ;Кол-во блоков в файле
;Подпрограммы MK-DOS
INIDRV = 120016 ; Инициализация драйвера дисковода
EMT6   = 120020 ; Команда EMT6 с автоповтором (исп. Rename)
INOUT  = 120022 ; Чтение/запись блока (160004 исп.буфер ДОС)
RDDIR  = 120024 ; Чтение каталога в буфер (@#DIR)
DIRFIN = 120026 ; Поиск файла в каталоге
DIRPRI = 120030 ; Вывод каталога на экран
FRFIN  = 120032 ; Поиск свободного места в каталоге
CREAT  = 120034 ; Создание записи о файле в каталоге
DELETE = 120036 ; Удаление файла (с запросом или без него)
SAVDIR = 120042 ; Запись каталога
EMT20  = 120044 ; Полная имитация EMT20 с исп. ячейки SCREEN
PRINAM = 120046 ; Вывод имени с без пробелов в конце
TXT    = 120050 ; Перемещаемый вывод надписей
STROKA = 120052 ; Редактор строки (исп. Rename)
OCTOUT = 120056 ; Вывод восьмеричного числа
DECOUT = 120060 ; Вывод десятичного числа
TST    = 120062 ; Замена управляющих кодов в R0 на пробелы
TST2   = 120064 ; Привести R0 к ЛАТ,ЗАГЛ регистру(корректно)
ERROR  = 120066 ; Расшифровка текстом No ошибки дисковода
FRFIN2 = 120120 ; Поиск свободного места по длине в блоках
CREAT2 = 120122 ; Создание записи о файле по длине в блоках


TTKS   = 177560 ; регистр состояния приёмника
TTKB   = 177562 ; регистр данных приёмника
TTPS   = 177564 ; регистр состояния передатчика
TTPB   = 177566 ; регистр данных передатчика
TTKINT = 0360
TTPINT = 0364
LTCINT = 0100

RCVBuffer=30000 ;буфер приёма данных длиной 4000 байт
IOBuffer =36000 ;какой-то буфер

XOFF    = 0x13
XON     = 0x11

; ═══════════════════════════════════════════════════════════════════════════

START$:         call    Prepare
; ───────────────────────────────────────────────────────────────────────────
BgColor:        .word   0               ; цвет фона
ColMask:        .word   52525           ; инверсная маска цвета символа
word_1010:      .word   0
SelColor:       .word   177777          ; маска выделения символа
AnsiOption:     .byte   377
byte_1015:      .byte   0
EchoOption:     .byte   0
CopyScrOption:  .byte   0               ; флаг ведения лога передачи
byte_1020:      .byte   0
AutoDLOption:   .byte   377
XonXofOption:   .byte   377
NewIRPSOption:  .byte   0

word_1246:      .word   0
word_1310:      .word   0

; ───────────────────────────────────────────────────────────────────────────

Process:        mov     #START$, SP
                mtps    #0
                clr     word_6642

14$:            tstb    @#TTPS          ; что там с передатчиком?
                bpl     1$              ; пока данные не переданы - переходим
; ───────────────────────────────────────────────────────────────────────────
                call    GetKeyAR        ; проверяем ввод с клавиатуры
                bcs     1$              ; ничего не нажато, или нажато в первый раз
                bitb    #140, R0        ; что за код?
                bne     2$              ; букво-цифра, перейдём туда
                tstb    R0              ; больше >200
                bmi     2$              ; тоже туда
                tst     PrefixKeyFlag   ; префикс?
                bne     2$              ; да - туда
                jsr     R5, ProcKeyChain
                .word   KeyChain1
                br      2$              ; если ничего не совпало
                br      0graf           ; горячие клавиши в терминале
                br      0povt
                br      0kt
                br      0blr
                br      0suu
; ───────────────────────────────────────────────────────────────────────────
0graf:          comb    EchoOption      ; СУ/Е(ГРАФ) - перекл. Эхо
                br      1$
; ───────────────────────────────────────────────────────────────────────────
0povt:          comb    AnsiOption      ; ПОВТ - перекл. АНСИ
                br      1$
; ───────────────────────────────────────────────────────────────────────────
0kt:            comb    CopyScrOption   ; КТ - перекл. Лог введённых данных
                br      1$
; ───────────────────────────────────────────────────────────────────────────
0blr:           call    DownloadFunc    ; БЛОК.РЕД - загрузка файла
                ;из этой п/п переход прямо в Process
; ───────────────────────────────────────────────────────────────────────────
0suu:           call    UploadFunc      ; СУ/У - передача файла
                halt

2$:             call    TerminalFunc

1$:             cmp     R4, RCVBuffPtr
                beq     14$
                movb    (R4)+, R0
                bic     #4000, R4
                tstb    CopyScrOption
                beq     5$
                mov     #76000, @#177716
                movb    R0, @SNDLogBuffPtr
                inc     SNDLogBuffPtr
                tst     SNDLogBuffPtr
                bpl     4$
                trap    4               ; вредная команда, которая ничего не делает, только курсор сбивает
                ; а должна была или выключать режим логирования, либо сохранять лог на диск
                ; а тут ещё и переполнение будет и порча данных.
4$:             mov     #16000, @#177716

5$:             tstb    AutoDLOption
                beq     6$
                call    CheckAutoDL

6$:             tst     word_1246
                bne     7$
                tstb    AnsiOption
                beq     10$
                cmpb    #33, R0
                bne     10$
                clr     word_1310
                mov     R4, word_1246
                br      14$

7$:             bitb    #140, R0
                beq     11$
                tst     word_1310
                bne     8$
                cmpb    #'[, R0
                bne     9$
                com     word_1310
                br      14$

8$:             cmpb    #'/, R0
                bhis    9$
                cmpb    #'?, R0
                bhi     14$
9$:             mov     word_1246, R4
                movb    #33, R0

10$:            call    sub_6734
                call    sub_2060

11$:            clr     word_1246
                call    KeyPressCheck
                bne     12$
                call    sub_6752
12$:            br      Process

KeyChain1:      .byte   5       ; СУ/Е(ГРАФ)
                .byte   1       ; ПОВТ
                .byte   3       ; КТ
                .byte   4       ; БЛОК РЕД
                .byte   25      ; СУ/У
                .byte   0       ; конец таблицы
                .even

; обработчик таблиц кодов
; входные параметры:
;   .word   адрес таблицы кодов, 0 - конец таблицы
;   br  переход, если ни один код не совпал
;   br  переход по первому коду
;   br  переход по второму коду
;   и.т.д.
ProcKeyChain:   push    R4              ; сохраним R4 в стеке
                mov     (R5), R4        ; берём адрес таблицы переходов
2$:             tstb    (R4)            ; конец таблицы?
                beq     1$              ; да - выходим
                cmpb    (R4)+, R0       ; смотрим очередной код
                bne     2$              ; не совпал - идём дальне
                sub     (R5), R4        ; совпал - получим его порядковый номер
                add     R4, R5          ; скорректируем адрес возврата
                add     R4, R5
                tst     (R5)+           ; перешагнём через переход по умолчанию
1$:             tst     (R5)+           ; перешагнём через адрес таблицы
                pop     R4
                rts     R5

; ───────────────────────────────────────────────────────────────────────────
; приём данных по прерыванию
VEC360:         push    R0
                movb    @#TTKB, R0      ; читаем полученный байт
                tstb    XonXofOption          ; ручное управление потоком?
                beq     1$              ; нет - переход
                cmpb    #XOFF, R0       ; приняли код 0x13?
                bne     2$              ; нет
                mov     (PC)+, (PC)+    ; приостанавливаем передачу
                .word   -1
FlagBlockTransmit:.word   0
                br      3$

2$:             cmpb    #XON, R0        ; приняли код 0x11?
                bne     1$              ; нет
                clr     FlagBlockTransmit ; разрешаем передачу дальше
                br      3$

1$:             movb    R0, @RCVBuffPtr ; помещаем данные в буфер
                inc     (PC)+
RCVBuffPtr:     .word   RCVBuffer
                bic     #4000, RCVBuffPtr   ; циклично
                inc     (PC)+
ReceiveCounter: .word   0
3$:             pop     R0
                rti

; ███████████████ S U B R O U T I N E ███████████████████████████████████████
;передача строки

SendSTRING:     push    R0              ; сохраняем R0

2$:             movb    (R1)+, R0       ; берём очередной байт
                beq     1$              ; 0 - конец
                call    SendCHAR        ; передаём
                br      2$              ; и т.д.

1$:             inc     R1              ; выравниваем адрес возврата
                bic     #1, R1
                pop     R0              ; восстанавливаем R0
                rts     R1              ; восстанавливаем R1 и выходим из п/п
; End of function SendSTRING


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
;передача символа

SendCHAR:       tstb    @#TTPS          ; смотрим состояние передатчика
                bpl     SendCHAR        ; пока буфер не пуст, подождём
                tstb    XonXofOption    ; ручное управление потоком?
                beq     2$              ; нет

1$:             tst     FlagBlockTransmit   ; передавать можно?
                bne     1$              ; пока нет, ждём

2$:             movb    R0, @#TTPB      ; передаём данные
                inc     (PC)+
SendCounter:    .word 0
                tst     SNDLogBuffPtr   ; а это наверное лог переданных данных
                bmi     3$              ; выключен.
                mov     #36000, @#177716    ; а если включен
                movb    R0, @SNDLogBuffPtr  ; сохраним и туда
                inc     SNDLogBuffPtr
                mov     #16000, @#177716
3$:             return
; End of function SendCHAR

; ───────────────────────────────────────────────────────────────────────────

TerminalFunc:   bic     #177400, R0
                tstb    AnsiOption
                bne     4$

6$:             clr     PrefixKeyFlag
                push    R0
                movb    byte_13016(R0), R0
                call    SendCHAR
                pop     R0
                tstb    EchoOption
                beq     3$
                cmpb    #37, R0
                bhis    1$
                jmp     PutChr80

1$:             cmpb    #12, R0
                bne     2$
                emt     16
                mov     #15, R0
                call    SendCHAR
2$:             emt     16
3$:             return

4$:             cmpb    #40, R0
                blos    6$
                tst     PrefixKeyFlag
                bne     6$
                jsr     R5,ProcKeyChain
                .word   KeyChain2
                br      6$
                br      0keyup
                br      0key37
                br      0keyrt
                br      0keylt
                br      0keysbr
                ;br      0sur
; ───────────────────────────────────────────────────────────────────────────
0sur:           jsr     R1, SendSTRING
                .asciz <33><133>"H"
                .even
                return

0keyup:         jsr     R1, SendSTRING
                .asciz <33><133>"A"
                .even
                return

                ; вот странно. тут код 37 делает Esc B
                ; а в другом месте Esc B делает код 33
                ; наверное тут ошибка.
                ; Тут нет ошибки. В драйвере клавиатуры код 33 подменяется на 37
0key37:         jsr     R1, SendSTRING
                .asciz <33><133>"B"
                .even
                return

0keyrt:         jsr     R1, SendSTRING
                .asciz <33><133>"C"
                .even
                return

0keylt:         jsr     R1, SendSTRING
                .asciz <33><133>"D"
                .even
                return

0keysbr:        jsr     R1, SendSTRING
                .asciz <33><133>"2J"
                .even
                return

KeyChain2:      .byte   32      ; Стрелка вверх
                .byte   37      ; СУ/Ъ (стрелка влево-вниз)
                .byte   31      ; Стрелка вправо
                .byte   10      ; Стрелка влево
                .byte   14      ; СБР
                .byte   22      ; СУ/R
                .byte   0
                .even

; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; вход: R4 - указатель в буфере приёма

sub_2060:       cmpb    #33, R0         ; ESC код?
                beq     1$

3$:             bic     #177400, R0
                movb    byte_12416(R0), R0
2$:             cmpb    #40, R0
                blos    9$
                emt     16
5$:             return

9$:             jmp     PutChr80

1$:             tstb    AnsiOption
                beq     3$
                movb    (R4)+, R0
                bic     #4000, R4
                mov     R4, word_1246
                cmpb    #133, R0 ; '['
                beq     4$
                call    ProcKeyChain
                .word   KeyChain_2060
                br      5$
                br      0D
                br      0E
                ;br      0M
0M:             jsr     R1,@TXT
                .asciz  <32>
                .even
                return

0D:             jsr     R1,@TXT
                .asciz  <33>
                .even
                return

0E:             jsr     R1,@TXT
                .asciz <12><15>
                .even
                return

4$:             movb    (R4)+, R0
                bic     #4000, R4
                cmpb    #72, R0 ; ':'
                blos    7$
                cmpb    #57, R0 ; '/'
                blo     4$
7$:             cmpb    #73, R0 ; ';'
                beq     4$

                mov     #EscCodes, R2
                mov     #EscCodeSubTbl, R5
8$:             tstb    (R2)
                beq     5$
                tst     (R5)+
                cmpb    (R2)+, R0
                bne     8$
                mov     word_1246, R4
                call    StrToDec        ; преобразование строки в десятичное число.
                                        ; вход: данные в буфере приёма
                                        ; выход: R1 - число
                jmp     @-(R5)

; End of function sub_2060

; ───────────────────────────────────────────────────────────────────────────
KeyChain_2060:  .byte   104     ; код D
                .byte   105     ; код E
                .byte   115     ; код M
                .byte   0       ; конец цепочки

EscCodes:       .asciz  "n!hlABCDmHfusJK"
                .even

EscCodeSubTbl:  .word   sub_EscCode156      ; cmd n
                .word   sub_EscCode041      ; cmd !
                .word   sub_EscCode150      ; cmd h
                .word   sub_EscCode154      ; cmd l
                .word   sub_EscCode101      ; cmd A
                .word   sub_EscCode102      ; cmd B
                .word   sub_EscCode103      ; cmd C
                .word   sub_EscCode104      ; cmd D
                .word   sub_EscCode155      ; cmd m
                .word   sub_EscCode110_146  ; cmd H,f
                .word   sub_EscCode110_146  ; cmd H,f
                .word   sub_EscCode165      ; cmd u
                .word   sub_EscCode163      ; cmd s
                .word   sub_EscCode112      ; cmd J
                .word   sub_EscCode113      ; cmd K

; ───────────────────────────────────────────────────────────────────────────
sub_EscCode156: cmp     #5, R1              ; cmd n
                bne     1$
                jsr     R1, SendSTRING
                .asciz <33><133>"0n"
                .even
2$:             return

1$:             cmp     #6, R1
                bne     2$
                jsr     R1, SendSTRING
                .asciz <33><133>""
                .even
                emt     26
                inc     R1
                inc     R2
                mov     R2, R0
                call    Dec2ToStr
                jsr     R1, SendSTRING
                .asciz ";"
                .even
                mov     R1, R0
                call    Dec2ToStr
                jsr     R1, SendSTRING
                .asciz "R"
                .even
                return

; ───────────────────────────────────────────────────────────────────────────
sub_EscCode041: jsr     R1, SendSTRING      ; cmd !
                .asciz <33><133>"!"
                .even
                return

; ───────────────────────────────────────────────────────────────────────────
sub_EscCode150: cmp     #24, R1             ; cmd h
                bne     1$
                mov     #-1, word_1010
1$:             return

; ───────────────────────────────────────────────────────────────────────────
sub_EscCode154: cmp     #24, R1             ; cmd l
                bne     1$
                clr     word_1010
1$:             return

; ───────────────────────────────────────────────────────────────────────────
sub_EscCode101: call    SetR1NotNull        ; cmd A
                mov     #32, R0
                br      loc_2426

; ───────────────────────────────────────────────────────────────────────────
sub_EscCode102: call    SetR1NotNull        ; cmd B
                mov     #33, R0             ; вот тут. А выше был код 37
                br      loc_2426

; ───────────────────────────────────────────────────────────────────────────
sub_EscCode103: call    SetR1NotNull        ; cmd C
                mov     #31, R0
                br      loc_2426

; ───────────────────────────────────────────────────────────────────────────
sub_EscCode104: call    SetR1NotNull        ; cmd D
                mov     #10, R0
loc_2426:       emt     16
                sob     R1, loc_2426
                return

; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; корректируем R1, если там 0, то меняем на 1
SetR1NotNull:   tst     R1
                bne     1$
                inc     R1
1$:             return
; End of function SetR1NotNull

; ───────────────────────────────────────────────────────────────────────────

sub_EscCode155: mov     R1,R0               ; cmd m
                beq     0c0
                jsr     R5,ProcKeyChain
                .word   KeyChain_Escm
                br      2$
                br      0c7
                br      0c36
                br      0c37
                br      0c40
                br      0c42
                br      0c45
                br      0c50
                br      0c51
                br      0c52
                br      0c54
                br      0c57
; ───────────────────────────────────────────────────────────────────────────
0c0:            clrb    @#PRPODC            ; код 0
                mov     #52525, ColMask
0c50:           clr     BgColor             ; код 50 (()
                clrb    @#PRINWS
                br      2$

0c7:            comb    @#PRINWS            ; код 7
                br      2$

0c36:                                       ; код 36
0c37:           clr     ColMask             ; код 37
                br      2$
0c40:                                       ; код 40 (пробел)
0c45:           mov     #52525, ColMask     ; код 45 (%)
                br      2$

0c42:           mov     #125252, ColMask    ; код 42 (")
                br      2$
0c51:                                       ; код 51 ())
0c57:           mov     #177777, BgColor    ; код 57 (/)
                br      2$

0c52:           mov     #52525, BgColor     ; код 52 (*)
                br      2$

0c54:           mov     #125252, BgColor    ; код 54 (,)
2$:             cmpb    #'m, R0
                bne     1$
                return

1$:             call    StrToDec        ; преобразование строки в десятичное число.
                                        ; вход: данные в буфере приёма
                                        ; выход: R1 - число
                br      sub_EscCode155
; ───────────────────────────────────────────────────────────────────────────

KeyChain_Escm:  .byte   7               ; код 7
                .byte   36              ; код 36
                .byte   37              ; код 37
                .byte   40              ; код 40 (пробел)
                .byte   42              ; код 42 (")
                .byte   45              ; код 45 (%)
                .byte   50              ; код 50 (()
                .byte   51              ; код 51 ())
                .byte   52              ; код 52 (*)
                .byte   54              ; код 54 (,)
                .byte   57              ; код 57 (/)
                .byte   0
                .even

; ───────────────────────────────────────────────────────────────────────────
sub_EscCode110_146:
                push    R1              ; cmd H,f
                cmpb    #';, R0
                beq     1$
                clr     R1
                br      2$

1$:             call    StrToDec        ; преобразование строки в десятичное число.
                                        ; вход: данные в буфере приёма
                                        ; выход: R1 - число
                dec     R1

2$:             tst     (SP)
                beq     3$
                dec     (SP)

3$:             pop     R2
                emt     24
                return

; ───────────────────────────────────────────────────────────────────────────
CloseOpenWindow:call    CloseWindow
; ───────────────────────────────────────────────────────────────────────────
sub_EscCode165: mov     ScrY, R2        ; cmd u
1$:             mov     ScrX, R1
                emt     24
                cmp     @#AS, ScrAS
                beq     2$
                dec     R2
                br      1$

2$:             return

; ───────────────────────────────────────────────────────────────────────────
sub_EscCode163: emt     26              ; cmd s
                mov     R1, (PC)+
ScrX:           .word 0
                mov     R2, (PC)+
ScrY:           .word 0
                mov     @#AS, (PC)+
ScrAS:          .word 0
                return

; ───────────────────────────────────────────────────────────────────────────
sub_EscCode112: cmp     #2, R1          ; cmd J
                bne     1$
                mov     #14, R0
                emt     16
6$:             return

1$:             tst     R1
                bne     2$
                emt     26
                push    R1
                push    R2
                mov     #27, R1
                sub     (SP), R1
                beq     3$

5$:             inc     R1
4$:             call    sub_3444
                inc     R2
                sob     R1, 4$
3$:             pop     R2
                pop     R1
                emt     24
                return

2$:             cmp     #1, R1
                bne     6$
                emt     26
                push    R1
                push    R2
                clr     R2
                emt     24
                mov     (SP), R1
                beq     3$
                br      5$

; ───────────────────────────────────────────────────────────────────────────
sub_EscCode113: cmp     #2, R1          ; cmd K
                bne     1$
                emt     26
                push    R2
                push    R1

3$:             call    sub_3444
4$:             pop     R1
                pop     R2
                emt     24
6$:             return

1$:             tst     R1
                bne     2$
                emt     26
                push    R2
                push    R1
                beq     3$
                mov     #117, R1 ; 'O'
                sub     (SP), R1
                beq     4$

7$:             inc     R1
                mov     #40, R0 ; ' '
                comb    byte_1015
5$:             call    PutChr80
                sob     R1, 5$
                clrb    byte_1015
                br      4$

2$:             cmp     #1, R1
                bne     6$
                emt     26
                push    R2
                push    R1
                beq     4$
                clr     CRDX80          ; Своя координата курсора Х
                br      7$

; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; преобразование строки в десятичное число.
; вход: данные в буфере приёма
; выход: R1 - число

StrToDec:       clr     R1              ; аккумулятор
1$:             clr     R0
                bisb    (R4)+, R0       ; берём код из буфера
                bic     #4000, R4       ; корректируем указатель
                cmpb    #':, R0         ; если код >= 72
                blos    2$              ; выходим
                cmpb    #'/, R0         ; если код <= 57
                bhis    2$              ; выходим.
                call    sub_3334        ; если цифра или двоеточие, обработаем
                br      1$              ; и повторим

2$:             return
; End of function StrToDec


; ███████████████ S U B R O U T I N E ███████████████████████████████████████


sub_3334:       sub     #'0, R0         ; вычитаем 0, получаем число от 0 до 10.
                bmi     1$              ; ещё раз убедимся, что на входе были корректные данные
                cmp     #10., R0        ; если результат >=10.
                blos    1$              ; выходим.
                asl     R1              ; умножаем на 10.
                push    R1
                asl     R1
                asl     R1
                add     (SP)+, R1
                add     R0, R1          ;прибавляем мл. разряд к результату.
1$:             return
; End of function sub_3334


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; преобразование  двузначного десятичного числа в строку
; вход: R0 - число
; выход: строка, отправленная по ИРПС
; если число больше 99. то алгоритм будет работать неправильно

Dec2ToStr:      clr     R5
                mov     #10., R3        ;база счисления
                cmp     R0, R3          ;если число < 10
                blo     sub_3424        ;просто выведем его

2$:             sub     R3, R0          ;вычитаем базу
                bmi     1$              ;пока возможно
                inc     R5              ;считаем порядок
                br      2$

1$:             add     R3, R0          ;прибавляем назад
                push    R0
                mov     R5, R0          ;и выводим полученный порядок
                call    sub_3424
                pop     R0              ;и второе число выведем.

sub_3424:       add     #'0, R0
                jmp     SendCHAR
; End of function Dec2ToStr


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; берём какой-то байт и зарисовываем им строку на экране

sub_3444:       push    R1
                clr     R1
                emt     24
                mov     @#AS, R5
                mov     #5, R1
                mov     BgColor, R0

1$:             mov     #74, R3
2$:             movb    R0, (R5)+
                movb    R0, 77(R5)
                sob     R3, 2$
                add     #104, R5
                bpl     3$
                sub     #40000, R5
3$:             sob     R1, 1$
                pop     R1
                return
; End of function sub_3444

; ───────────────────────────────────────────────────────────────────────────
VEC04:          jsr     R5, PUSHAR
                call    sub_EscCode163      ; cmd s
                mov     #V04$2, @#4
                call    DrawWindow
                .word 40056
                .word 21
                .word 170
                call    DrawScrText
                .word MainMenu
                .word 1200
; ───────────────────────────────────────────────────────────────────────────
; теперь выведем состояние опций
13$:            tstb    EchoOption
                bne     1$
                trap    0
                br      2$
1$:             trap    1

2$:             tstb    AnsiOption
                bne     3$
                trap    2
                br      4$
3$:             trap    3

4$:             tstb    AutoDLOption
                bne     5$
                trap    36
                br      6$
5$:             trap    35

6$:             tstb    CopyScrOption
                bne     7$
                trap    40
                br      8$
7$:             trap    37

8$:             tstb    XonXofOption
                bne     9$
                trap    56
                br      10$
9$:             trap    55

10$:            tstb    NewIRPSOption
                bne     11$
                trap    60
                br      12$
11$:            trap    57

12$:            call    InputKeyAR
                emt     264             ; Привести R0 к ЛАТ,ЗАГЛ регистру(корректно)

                jsr     R5,ProcKeyChain
                .word   KeyChain_Main
                br      12$
                br      0T
                br      0E
                br      0A
                br      0L
                br      0C
                br      0X
                br      0N
                br      0D
                br      0U
                br      0key12
                br      0key33
                br      0Q

0E:             comb    EchoOption
                br      13$

0A:             comb    AnsiOption
                br      2$

0L:             comb    AutoDLOption
                br      4$

0C:             comb    CopyScrOption
                br      6$

0X:             comb    XonXofOption
                br      8$

0N:             comb    NewIRPSOption
                br      10$
                ; Download file
0D:             jsr     R5, POPAR
                call    CloseOpenWindow
                call    DownloadFunc    ; из этой п/п переход прямо в Process
; ───────────────────────────────────────────────────────────────────────────
                ; Upload file
0U:             jsr     R5, POPAR
                call    CloseOpenWindow
                call    UploadFunc
; ───────────────────────────────────────────────────────────────────────────
0T:             ; Выход обратно в терминал
0key12:
0key33:         call    CloseOpenWindow
                jsr     R5, POPAR
                mov     #VEC04, @#4
                jmp     Process

0Q:
V04$2:          call    OnQuit          ; Восстановление векторов перед выходом
                halt                    ; выход. и заодно, конец цепочки.

KeyChain_Main:  .byte   124             ; T
                .byte   105             ; E
                .byte   101             ; A
                .byte   114             ; L
                .byte   103             ; C
                .byte   130             ; X
                .byte   116             ; N
                .byte   104             ; D
                .byte   125             ; U
                .byte   012             ; <12>
                .byte   033             ; <33>
                .byte   121             ; Q
                .byte   0
                .even
; ───────────────────────────────────────────────────────────────────────────

; ███████████████ S U B R O U T I N E ███████████████████████████████████████
;считаем КС массива, по одному байту за раз.
;вход:  R1 - адрес массива
;       word_4250 - промежуточное значение
;выход: word_4250 - какое-то число, возможно КС.

S04134:         push    R0
                push    R1
                push    R2
                push    R3
                push    R5
                mov     word_4250, R3
                mov     #1, R5
                mov     #177400, R2
                br      4206$
; End of function S04134


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
;считаем КС массива.
;вход:  R1 - адрес массива
;       R5 - длина массива
;выход: word_4250 - какое-то число, возможно КС.
S04164:         push    R0
                push    R1
                push    R2
                push    R3
                push    R5
                clr     R3
                mov     #177400, R2
1$:             movb    (R1)+, R0
4206$:          swab    R3
                xor     R3, R0
                bic     R2, R0
                asl     R0
                mov     word_13420(R0), R0
                clrb    R3
                xor     R0, R3
                sob     R5, 1$
                mov     R3, word_4250
                pop     R5
                pop     R3
                pop     R2
                pop     R1
                pop     R0
                return
word_4250:      .word 0
; End of function S04164

; ───────────────────────────────────────────────────────────────────────────
S04252:         call    S04330
                bcs     2$
                cmpb    #21, R0
                beq     S04252
                cmpb    #23, R0
                beq     S04252
                cmpb    #15, R0
                beq     1$
                cmpb    #12, R0
                beq     1$
                cmpb    #30, R0
                beq     1$
                bitb    #140, R0
                beq     S04252
1$:             tst     (PC)+
2$:             sec
                return

; ───────────────────────────────────────────────────────────────────────────
S04330:         call    S04336
                .word   12
                return

; ───────────────────────────────────────────────────────────────────────────
;вход: слово за командой - аргумент.
;   если аргумент не 0 - ждать новые данные в буфере
;выход: R0 - новый байт из буфера
;       С==0
;   если 0 - то ничего не ждать.
;выход: R0 == -1
;       С==1
S04336:         mov     (SP), R0        ;адрес возврата
                mov     (R0)+, word_6636 ;аргумент
                mov     R0, (SP)        ;корректируем адрес возврата
1$:             cmp     RCVBuffPtr, R4  ;в буфер приёма что-нибудь попало?
                bne     2$              ;да
                tst     word_6636       ;нет - а чё аргумент?
                bne     1$              ;не = 0, ждём
                mov     #-1, R0         ;иначе - R0=-1
                br      3$

2$:             call    LogRCVData
                tst     (PC)+
3$:             sec
                return

LogRCVData:     cmp     RCVBuffPtr, R4      ; в буфер приёма что-нибудь попало?
                beq     LogRCVData          ; нет ещё
                clr     R0
                bisb    (R4)+, R0           ; возьмём из буфера новый байт
                bic     #4000, R4
                tst     SNDLogBuffPtr       ; буфер лога переполнился?
                bmi     1$                  ; да - выход
                mov     #36000, @#177716    ; нет - поместим новый байт в лог
                movb    R0, @SNDLogBuffPtr
                inc     SNDLogBuffPtr
                mov     #16000, @#177716
1$:             return

; ───────────────────────────────────────────────────────────────────────────
; получение нового кода клавиши с автоповтором и ожиданием нажатия клавиши.
InputKeyAR:     call    GetKeyAR
                bcs     InputKeyAR
                return

; ───────────────────────────────────────────────────────────────────────────
; получение нового кода клавиши с автоповтором.
; выход: C если клавиша не нажата или нажата в первый раз
GetKeyAR:       tstb    PRZKB           ; новый код в буфер клавиатуры поступил?
                beq     1$              ; нет
                mov     #2000, GetFirstKeyDelay ;да - инициализируем задержку
                br      2$              ; и идём получать код клавиши

1$:             call    KeyPressCheck   ; проверим, клавиша нажата?
                bne     3$              ; нет
                dec     (PC)+           ; а если нажата, считаем задержку
GetFirstKeyDelay:.word 2000             ; если очень долго держать клавишу нажатой,
                                        ; тут произойдёт переполнение и снова будет
                                        ; считаться, что клавиша нажата впервые,
                                        ; но значение задержки уже будет 77777
                bpl     3$              ; ещё не пора
                call    AutoRepeatDelay ; пора - сделаем ещё задержку автоповтора
2$:             call    @#101122        ; получение нового кода клавиши, через драйвер клавиатуры
                tst     (PC)+
3$:             sec
                return

; ───────────────────────────────────────────────────────────────────────────
;4414 подпрограмма, которая никогда не вызывается и нигде не используется
;что-то инвертирует на экране. похоже на курсор в меню.
;                mov     word_10166, R0
;                mov     word_10172, R1
;1$:             dec     R1
;                bmi     2$
;                add     #1200, R0
;                br      1$
;
;                mov     word_10166, R0
;                add     @#BAZVP, R0
;                bpl     2$
;                sub     #40000, R0
;2$:             mov     #12, R2
;3$:             mov     word_10170, R1
;4$:             comb    (R0)+
;                sob     R1, 4$
;                add     #100, R0
;                bpl     5$
;                sub     #40000, R0
;5$:             sub     word_10170, R0
;                sob     R2, 3$
;                return

; ───────────────────────────────────────────────────────────────────────────
; рамку что ли какую-то рисуем
DrawWindow:     jsr     R5, PUSHAR
                mov     14(SP), R4
                mov     (R4)+, R5       ;берём первый аргумент
                add     @#BAZVP, R5
                bpl     1$
                sub     #40000, R5
1$:             mov     R5, (PC)+       ;это будет адрес экрана
WndAddr:        .word   0
                mov     (R4)+, R1       ;берём второй аргумент, это ширина
                mov     R1, (PC)+
WndWidth:      .word   0
                mov     (R4)+, R2       ;берём третий аргумент, это высота
                mov     R2, (PC)+
WndHeight:      .word   0
                mov     R4, 14(SP)
                mov     (PC)+, R4
off_4636:       .word   FreeSpace
                call    S05204          ;корректируем входные параметры и задаём R3
                mov     R1, R0
                br      1$

2$:             inc     R4
1$:             movb    (R5)+, (R4)+    ;копируем из экрана в буферную область
                clrb    (R4)
                br      5$

3$:             mov     R1, R0
4$:             cmpb    (R5), -1(R4)    ;сложно как-то копируем
                bne     2$
                cmpb    #376, (R4)
                blos    2$
                inc     R5
5$:             incb    (R4)
                sob     R0, 4$
                call    S05072          ;сдвигаем адрес экрана на строку вниз.
                sob     R2, 3$

                mov     WndHeight, R2
                mov     WndAddr, R5     ;адрес экрана
                dec     R1
6$:             mov     R1, R0
7$:             mov     R5, R4
                add     #601, R4
                bpl     8$
                sub     #40000, R4
8$:             clrb    (R4)            ;теперь каким-то сложным способом
                clrb    (R5)+           ;очищаем то, что скопировали в буфер
                sob     R0, 7$
                call    S05072          ;сдвигаем адрес экрана на строку вниз.
                sob     R2, 6$

                mov     WndAddr, R5     ;адрес экрана
                call    S05062          ;инвертируем одну строку экрана
                call    S05072          ;сдвигаем адрес экрана на строку вниз.
                mov     #17, R2
                mov     #360, R4
                call    S05050          ;рисуем границы, левую R2 и правую R4, и двигаем адрес экрана на строку вниз
                call    S05062          ;инвертируем одну строку экрана
                sub     R1, R5
                mov     #317, R2
                mov     #363, R4
                call    S05050          ;рисуем границы, левую R2 и правую R4, и двигаем адрес экрана на строку вниз

                mov     WndHeight, R0
                sub     #6, R0
9$:             call    S05050          ;рисуем границы, левую R2 и правую R4, и двигаем адрес экрана на строку вниз
                sob     R0, 9$

                call    S05062          ;инвертируем одну строку экрана
                sub     R1, R5
                call    S05050          ;рисуем границы, левую R2 и правую R4, и двигаем адрес экрана на строку вниз
                mov     #17, R2
                mov     #360, R4
                call    S05050          ;рисуем границы, левую R2 и правую R4, и двигаем адрес экрана на строку вниз
                call    S05062          ;инвертируем одну строку экрана
                br      jmp_5176

; ───────────────────────────────────────────────────────────────────────────
;рисуем границы, левую R2 и правую R4, и двигаем адрес экрана на строку вниз
S05050:         movb    R2, (R5)
                add     R1, R5
                movb    R4, -1(R5)
                ;br      S05072
; ───────────────────────────────────────────────────────────────────────────
;сдвигаем адрес экрана на строку вниз.
S05072:         add     R3, R5
                bpl     1$
                sub     #40000, R5
1$:             sub     R1, R5
                return
; ───────────────────────────────────────────────────────────────────────────
;инвертируем одну строку экрана
S05062:         mov     R1, R0
1$:             comb    (R5)+
                sob     R0, 1$
                return

; ───────────────────────────────────────────────────────────────────────────
;а это наоборот, восстанавливаем содержимое экрана
CloseWindow:    jsr     R5, PUSHAR
                mov     WndAddr, R5
                mov     WndWidth, R1
                mov     WndHeight, R2
                mov     off_4636, R4
                call    S05204          ;корректируем входные параметры и задаём R3
                mov     R1, R0
                inc     R0
                br      3$

1$:             mov     R1, R0
2$:             movb    R3, (R5)+
                decb    (R4)
                bne     4$
                inc     R4
3$:             movb    (R4)+, R3
4$:             sob     R0, 2$
                add     #100, R5
                bpl     5$
                sub     #40000, R5
5$:             sub     R1, R5
                sob     R2, 1$
jmp_5176:       jsr     R5, POPAR
                return

; ───────────────────────────────────────────────────────────────────────────
;корректируем входные параметры и задаём R3
S05204:         inc     R1
                add     #6, R2
                mov     #100, R3
                return

; ───────────────────────────────────────────────────────────────────────────
;вывод текста в то место, где рисовали рамку
DrawScrText:    mov     #AS, R3
                mov     (SP), R2
                mov     (R2)+, R1       ; берём первый аргумент, адрес текста
                mov     WndAddr, (R3)
                add     (R2)+, (R3)     ; берём второй аргумент, смещение от адреса экрана рамки
                bpl     1$
                sub     #40000, (R3)
1$:             mov     R2, (SP)
                add     #2, (R3)
                br      3$

2$:             add     #1200, (R3)
                bpl     3$
                sub     #40000, (R3)
3$:             clr     R2
4$:             movb    (R1)+, R0
                beq     6$
                cmpb    #12, R0
                bne     5$
                sub     R2, (R3)
                br      2$

5$:             emt     16
                bitb    #140, R0
                beq     4$
                inc     R2
                br      4$

6$:             return

; ───────────────────────────────────────────────────────────────────────────
;заполняем экран фоном
FillScr:        mov     #200, R4
FillScr2:       mov     #40000, R5
1$:             mov     #10421, R0
                mov     #40, R1
2$:             mov     R0, (R5)+
                sob     R1, 2$
                mov     #42104, R0
                mov     #40, R1
3$:             mov     R0, (R5)+
                sob     R1, 3$
                sob     R4, 1$
                return

; ───────────────────────────────────────────────────────────────────────────
;очистка экрана
ClrScr:         mov     #40000, R5
1$:             clr     (R5)+
                tst     R5
                bpl     1$
                return

; ███████████████ S U B R O U T I N E ███████████████████████████████████████
;вывод символа в режиме 80 симв.в строке
PutChr80:       push    R0
                push    R1
                push    R2
                push    R3
                push    R4
                push    R5
                com     @#177660        ; запретим прерывания от клавиатуры
                bic     #177400, R0
                mov     #111576, R2     ;адрес стандартного шрифта
                aslb    R0              ;умножаем на 2
                bcc     2$              ;если код был < 200, пойдём обрабатывать
                cmp     #100, R0        ;если код был > 240,
                blo     1$              ;тоже пойдём обрабатывать
                mov     #CHR200$237, R2 ;для кодов 200..240 будет своя матрица символов
                br      2$

1$:             add     #300, R0        ;коды 241..377
2$:             add     R0, R2          ;умножаем на 10.
                asl     R0
                asl     R0
                add     R2, R0
                mov     #10., R2
                call    sub_5730
3$:             movb    (R0), R1
                tst     SelColor
                bne     4$
                asr     R1
                bisb    (R0), R1
                bicb    ColMask, R1
4$:             inc     R0
                push    R0
                mov     BgColor, R0
                beq     5$
                bis     SelColor, R0
                xor     R0, R1
5$:             pop     R0
                tstb    @#PRINWS
                beq     6$
                comb    R1
6$:             bic     #177700, R1
                add     R4, PC          ;это не только адрес маски оказывается, а ещё и смещение
                asl     R1
                asl     R1              ;R4==1
                asl     R1
                asl     R1              ;R4==3
                asl     R1
                asl     R1              ;R4==5
                asl     R1
                bicb    R5, (R3)        ;R4==7
                bisb    R1, (R3)+
                swab    R1
                swab    R5
                bicb    R5, (R3)
                bisb    R1, (R3)
                swab    R5
                add     #77, R3
                bpl     7$
                sub     #40000, R3
7$:             sob     R2, 3$

                inc     CRDX80          ; Своя координата курсора Х
                tstb    byte_1015
                bne     8$
                emt     26
                cmp     #80., R1
                bhi     8$
                clr     CRDX80          ; Своя координата курсора Х
                mov     #12, R0
                emt     16
8$:             pop     R5
                pop     R4
                pop     R3
                pop     R2
                pop     R1
                pop     R0
                clr     @#177660        ;обратно разрешим прерывания
                return
CRDX80:         .word   0               ; Своя координата курсора Х
; End of function PutChr80


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

sub_5730:       mov     CRDX80, R4              ; Своя координата курсора Х
                movb    byte_14510(R4), R3      ; номер байта в строке для 80 симв. в строке
                movb    byte_14634(R4), R4      ; адрес маски отсечения для 80 символов в строке
                mov     word_14760(R4), R5      ; маска отсечения для 80 символов в строке
                asl     R4
                add     @#AS, R3
                return
; End of function sub_5730


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; Сохраняем в стеке все регистры
PUSHAR:         push    R4
                push    R3
                push    R2
                push    R1
                push    R0
                push    R5
                rts     R5
; End of function PUSHAR


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; Восстанавливаем из стека все регистры
POPAR:          pop     R0
                pop     R0
                pop     R1
                pop     R2
                pop     R3
                pop     R4
                rts     R5
; End of function POPAR

; ───────────────────────────────────────────────────────────────────────────
;6014 функция нигде не используется и никогда не вызывается
;кажись это функция редактирования строки.
;                push    R5
;                mov     #AS, R5
;                mov     R2, R4
;                mov     R2, R3
;
;1$:             tstb    (R3)+
;                bne     3$
;                dec     R3
;2$:             movb    #40, (R3)+
;                sob     R0, 2$
;                br      4$
;
;3$:             sob     R0, 1$
;4$:             clrb    (R3)
;                br      8$
;
;10$:            mov     (R5), word_10202
;                call    S06640
;                emt     220             ; Команда EMT6 с автоповтором (исп. Rename)
;                bit     #140, R0
;                beq     5$
;                tstb    (R2)
;                beq     10$
;                push    R0
;                call    sub_6234
;                pop     R0
;                movb    R0, (R2)+
;                iot
;                br      10$
;
;5$:             bis     #4000, R0
;                mov     PC, R1
;6$:             tst     (R1)
;                beq     10$
;                cmp     R0, (R1)+
;                bne     6$
;                jmp     (R1)
;
;; ───────────────────────────────────────────────────────────────────────────
;                .word 4010      ;стрелка влево
;                cmp     R2, R4
;                beq     10$
;                dec     R2
;                dec     (R5)
;                br      10$
;; ───────────────────────────────────────────────────────────────────────────
;                .word 4031      ;стрелка вправо
;                tstb    (R2)
;                beq     10$
;                inc     R2
;                inc     (R5)
;                br      10$
;; ───────────────────────────────────────────────────────────────────────────
;                .word 4030      ;забой
;                cmp     R2, R4
;                beq     10$
;                dec     (R5)
;                dec     R2
;                mov     R2, R1
;7$:             movb    1(R1), (R1)+
;                bne     7$
;                movb    #40, -(R1)
;8$:             call    S06262
;                br      10$
;
;; ───────────────────────────────────────────────────────────────────────────
;                .word 4003      ;КТ
;                br      9$
;; ───────────────────────────────────────────────────────────────────────────
;                .word 4012      ;Ввод
;                tst     (PC)+
;9$:             sec
;                pop     R5
;                return
;; ───────────────────────────────────────────────────────────────────────────
;                .word 0         ; конец цепочки
;
;
;; ███████████████ S U B R O U T I N E ███████████████████████████████████████
;; функция используется только в функции редактирования строки,
;; которая нигде не используется
;sub_6234:       tstb    (R2)
;                beq     7$
;                mov     R2, R1
;1$:             tstb    (R1)+
;                bne     1$
;                tst     -(R1)
;                br      3$
;
;2$:             movb    -(R1), 1(R1)
;3$:             cmp     R1, R2
;                bgt     2$
;
;S06262:         mov     R2, R1
;4$:             movb    (R1)+, R0
;                beq     5$
;                iot
;                br      4$
;
;5$:             sub     R2, R1
;                dec     R1
;                ble     7$
;6$:             dec     (R5)
;                sob     R1, 6$
;7$:             return
;; End of function sub_6234

; ───────────────────────────────────────────────────────────────────────────
; опять чтоль преобразование десятичного числа в строку.
; и вывод его на экран и в буфер
;теперь уже 32х разрядного
;вход:  R1 - адрес числа
;       R0 - адрес буфера, куда строку формировать. если 0,
;       то не надо в буфер, а просто вывести на экран.
S06310:         jsr     R5, PUSHAR
                mov     R0, word_6400
                mov     #10., R4
                mov     (R1)+, R0
                mov     (R1), R1
                clr     R2
1$:             clr     R3
                clr     R5

2$:             sub     R4, R0
                bcc     3$
                sbc     R1
                bmi     4$
3$:             inc     R3
                bne     2$
                inc     R5
                br      2$

4$:             add     R4, R0
                add     #'0, R0
                inc     R2
                movb    R0, -(SP)
                mov     R5, R1
                mov     R3, R0
                bne     1$
                mov     (PC)+, R1
word_6400:      .word 0
5$:             movb    (SP)+, R0
                tst     R1
                beq     6$
                movb    R0, (R1)+
6$:             iot
                sob     R2, 5$
                clrb    (R1)
                jmp     jmp_5176

; ───────────────────────────────────────────────────────────────────────────
;6424 никогда и нигде не используется.
;                clr     @#BUFKL
;                emt     220             ; Команда EMT6 с автоповтором (исп. Rename)
;                emt     264             ; Привести R0 к ЛАТ,ЗАГЛ регистру(корректно)
;                cmpb    #12, R0
;                bne     1$
;                tst     (PC)+
;1$:             sec
;                return

; ───────────────────────────────────────────────────────────────────────────
AutoRepeatDelay:
                push    R0
                mov     #5000, R0
                sob     R0, .
                pop     R0
                return

; ███████████████ S U B R O U T I N E ███████████████████████████████████████


KeyPressCheck:  call    DriveOff
                bit     #100, @#177716
                return
; End of function KeyPressCheck

; ███████████████ S U B R O U T I N E ███████████████████████████████████████

;прекращаем дисководную активность
DriveOff:       clr     @#177130
                clr     @BLK            ; Адрес блока параметров диска
                return
; End of function DriveOff

; ───────────────────────────────────────────────────────────────────────────
; Восстановление векторов перед выходом
OnQuit:         mov     V30BUF, @#30
                clr     @#SCREEN
                mov     #100000, @#4
                mov     #40000, @#177662
                clr     @#TTKS
                return

; ───────────────────────────────────────────────────────────────────────────
VEC100:         push    R0
                mov     #word_6632, R0
                dec     (R0)
                bpl     1$
                mov     #49., (R0)+
                inc     (R0)+
                dec     (R0)
1$:             dec     (PC)+
word_6610:      .word 19.
                bpl     2$
                mov     #19., word_6610
                call    S06640
2$:             pop     R0
                rti
; ───────────────────────────────────────────────────────────────────────────
word_6632:      .word 49.
word_6634:      .word 0
word_6636:      .word 0

; ███████████████ S U B R O U T I N E ███████████████████████████████████████

sub_6752:       clr     word_6642
                tst     word_6650
                beq     S06640
                return
; End of function sub_6752

; ███████████████ S U B R O U T I N E ███████████████████████████████████████

S06640:         tst     (PC)+
word_6642:      .word 0
                bne     6750$

loc_6646:       com     (PC)+
word_6650:      .word 0

                jsr     R5, PUSHAR
                call    sub_5730
                mov     #2, R2
                add     #700, R3
                call    @#111434        ; подготовка для вывода строки ИЗ МАТРИЦЫ СИМВОЛА

1$:             movb    (R3), R0
                xor     R5, R0
                movb    R0, (R3)
                swab    R5
                movb    1(R3), R0
                xor     R5, R0
                swab    R5
                movb    R0, 1(R3)
                call    @#111434        ; подготовка для вывода строки ИЗ МАТРИЦЫ СИМВОЛА
                sob     R2, 1$
                jmp     jmp_5176

; ███████████████ S U B R O U T I N E ███████████████████████████████████████

sub_6734:       mov     #-1, word_6642
                tst     word_6650
                bne     loc_6646
6750$:          return
; End of function sub_6734

; ───────────────────────────────────────────────────────────────────────────

; Перехватчик некоторых ЕМТ и выполнитель п/п МКДОС ЕМТ.
; EMT 216 - п/п по адресу 120016 Инициализация драйвера дисковода
; EMT 220 - п/п по адресу 120020
; и т.д.
VEC30:          push    R5
                mov     2(SP), R5
                mov     -(R5), R5       ; Получим код команды EMT
                cmp     #104016, R5     ; перехватываем некоторые ЕМТы
                beq     E16H$
                cmp     #104020, R5
                beq     E20H$
                cmp     #104024, R5
                beq     E24H$
                cmp     #104026, R5
                beq     E26H$
                tstb    R5              ; остальные стандартные ЕМТы - пропускаем
                bpl     loc_7076        ; ЕМТ 200 и более - обработаем сами
                sub     #104200-120000, R5 ; Получим адрес, начиная с 120000
                mtps    4(SP)           ; бессмысленно портим PS в стеке
                mov     (R5), R5        ; выберем адрес подпрограммы МКДОС
                mov     2(SP), 4(SP)    ; адрес возврата из прерывания на место PS
                mov     (SP)+, (SP)     ; содержимое R5 на место PC
                rts     R5              ; Восстанавливаем R5 и переходим выполнять п/п МКДОС

loc_7076:       pop     R5
                jmp     @(PC)+
V30BUF:         .word   0
; ───────────────────────────────────────────────────────────────────────────
; Перехватчик ЕМТ 20
E20H$:          movb    (R1)+, R0
                beq     loc_7376
                cmpb    #11, R0         ; коды 1..11 - количество пробелов
                blo     1$              ; Остальное - как обычно
                movb    R0, R2
                mov     #40, R0
2$:             iot
                sob     R2, 2$
                br      E20H$

1$:             emt     16
                br      E20H$
; ───────────────────────────────────────────────────────────────────────────
; Перехватчик ЕМТ 16
E16H$:          call    sub_6734
                bit     #140, R0        ; если коды 0..37, 200..237
                beq     1$              ; пойдём обработаем
                iot                     ; иначе - выведем
                br      loc_7376

1$:             push    R0
                push    R1
                push    R2
                bis     #4000, R0
                mov     PC, R1
2$:             tst     (R1)
                beq     4$
                cmp     (R1)+, R0
                bne     2$
                jmp     (R1)
; ───────────────────────────────────────────────────────────────────────────
                .word 4012              ; код 12
3$:             mov     #33, R0         ; обрабатываем так - стрелка вниз
4$:             call    @100016         ; стандартный EMT 16
                br      6$
; ───────────────────────────────────────────────────────────────────────────
                .word 4037              ; код 37
                br      3$              ; обрабатываем так же, как и 12
; ───────────────────────────────────────────────────────────────────────────
                .word 4015              ; код 15
                clr     CRDX80          ; Своя координата курсора Х
                tst     word_1010
                bne     3$
                br      6$
; ───────────────────────────────────────────────────────────────────────────
                .word 4014              ; код 14 - сбр
                clr     CRDX80          ; Своя координата курсора Х
                br      4$
; ───────────────────────────────────────────────────────────────────────────
                .word 4010              ; код 10 - стрелка влево
                tst     CRDX80          ; Своя координата курсора Х
                beq     6$
                dec     CRDX80          ; Своя координата курсора Х
                br      6$
; ───────────────────────────────────────────────────────────────────────────
                .word 4011              ; код 11 - таб
                emt     26
                mov     R1, R0
                com     R0
                bic     #177770, R0
                inc     R0
                add     R0, R1
                emt     24
                br      6$
; ───────────────────────────────────────────────────────────────────────────
                .word 4030              ; код 30 - забой
                tst     W80SLN          ; флаг, 80 символов в строке
                beq     4$
                dec     CRDX80          ; Своя координата курсора Х
                mov     #40, R0
                call    PutChr80
                dec     CRDX80          ; Своя координата курсора Х
                br      6$
; ───────────────────────────────────────────────────────────────────────────
                .word 4031              ; код 31 - стрелка вправо
                cmp     CRDX80, #79.    ; Своя координата курсора Х
                blo     5$
                clr     CRDX80          ; Своя координата курсора Х
                br      3$

5$:             inc     CRDX80          ; Своя координата курсора Х
6$:             pop     R2
                pop     R1
                pop     R0
loc_7376:       pop     R5
                rti
; ───────────────────────────────────────────────────────────────────────────
                .word 0                 ; всё, конец цепочки

; ───────────────────────────────────────────────────────────────────────────
; Перехватчик ЕМТ 24 - установка координат курсора
E24H$:          tst     (PC)+
W80SLN:         .word 177777            ; флаг, 80 символов в строке
                beq     loc_7076
                mov     R1, CRDX80      ; Своя координата курсора Х
                clr     R1
                call    @100024         ;стандартный EMT 24
                br      loc_7376

; ───────────────────────────────────────────────────────────────────────────
; Перехватчик ЕМТ 26 - получение координат курсора
E26H$:          call    @100026         ;стандартный EMT 26
                tst     W80SLN          ; флаг, 80 символов в строке
                beq     loc_7376
                mov     CRDX80, R1      ; Своя координата курсора Х
                br      loc_7376

; ───────────────────────────────────────────────────────────────────────────
; Команда IOT. Вывод символа
; Входной параметр в R0 - код символа
VEC20:          jsr     R5, PUSHAR
                bic     #177400, R0
                aslb    R0
                bcc     1$
                add     #300, R0
1$:             mov     R0, R2
                asl     R0
                asl     R0
                add     R2, R0
                add     #111576, R0     ; Получаем адрес символа в шрифте
                mov     #5, R2
                mov     #200, R4
                mov     #NOMSIM, R1     ; Системные ячейки драйвера экрана
                inc     (R1)+           ; Увеличиваем номер символа на экране
                mov     (R1), R3        ; Абсолютный адрес курсора в ОЗУ экрана
                inc     (R1)
                mov     word_10174, R1  ; какая-то маска
                tstb    @#PRPODC        ; Подчёркивание включено?
                bne     2$              ; да
                asl     R1              ; нет - скорректируем маску
2$:             mov     (R0), R5        ; берём сразу 2 байта из матрицы символа
                tstb    57
                bne     3$
                tstb    @#PRPODC        ; что там с подчёркиванием?
                beq     4$              ; нету
3$:             asr     R5              ; а если есть - ужирним символ
                bis     (R0), R5
                bic     R1, R5          ; применим маску
                tstb    @#57
                beq     4$
                push    R5              ; ещё сильнее ужирним
                asr     R5
                bis     (SP)+, R5
4$:             tstb    @#PRINWS        ; Инверсия символа включена?
                beq     5$              ; нет
                com     R5              ; да - проинвертируем
5$:             tst     (R0)+           ; подвинем указатель к следующим байтам из матрицы символа
                movb    R5, (R3)        ; рисуем первый байт на экране
                swab    R5
                movb    R5, 100(R3)     ; и второй (тут смелое допущение, что R3 никогда не будет 777хх)
                add     R4, R3          ; прибавляем смещение
                bpl     6$              ; нужно ли корректировать адрес?
                sub     #40000, R3      ; если нужно - скорректируем
6$:             sob     R2, 2$
                jsr     R5, POPAR
                rti

; ───────────────────────────────────────────────────────────────────────────
VEC274:         com     @#177660        ; запретим прерывания от клавиатуры
                push    R0
                call    GETCHR
                bis     #600, R0
                br      9$

; ───────────────────────────────────────────────────────────────────────────
VEC60:          com     @#177660        ; запретим прерывания от клавиатуры
                push    R0
                call    GETCHR
                tst     (PC)+           ; префикс был нажат?
PrefixKeyFlag:  .word 0
                bne     1$              ; да - переход
                cmpb    #23, R0         ; если ВС
                bne     2$
                com     PrefixKeyFlag   ; переключаем флаг префикса
                br      6$

1$:             bicb    #340, R0        ; обработаем код после префикса
                br      8$

2$:             cmpb    #3, R0          ; если КТ
                bne     3$
                movb    #33, R0         ; заменим его на префикс Esc
                br      8$

3$:             cmpb    #33, R0         ; если 33
                bne     4$
                movb    #37, R0         ; подменим его на 37
                br      8$

4$:             cmpb    #16, R0         ; если РУС
                bne     5$
                movb    #200, @#PRRUS   ; зададим режи Рус
                br      6$

5$:             cmpb    #17, R0         ; если ЛАТ
                bne     7$
                clrb    @#PRRUS         ; зададим режим Лат
6$:             clr     R0              ; а код обнулим и флаг нового кода тоже
                br      9$

7$:             cmpb    #100, R0
                bhi     8$
                bisb    @#PRRUS, R0     ; для букв применим рус/лат
8$:             bis     #400, R0        ; в ст. байте будет флаг нового кода
9$:             mov     R0, @#BUFKL
                pop     R0
                clr     @#177660
                rti


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

GETCHR:         push    R2
                push    R3
                mov     #2, R2
                call    @#102056        ; получение скан кода и звук нажатия
                pop     R3
                pop     R2
                return
; End of function GETCHR

; ───────────────────────────────────────────────────────────────────────────
VEC34:          push    R5
                mov     2(SP), R5
                mov     -(R5), R5       ; Получим код команды TRAP
                movb    R5, R5          ; код трапа, со знаком
                bmi     6$              ; если >= 200, то игнорируем
                push    R0
                push    R1
                mov     #TRPRES, R1     ; массив данных для соответствующих трапов.
                                        ; формат:
                                        ; .word адрес вывода на экран
                                        ; .asciz текст
                                        ; .even
1$:             dec     R5              ; уменьшим номер трапа
                bmi     4$              ; всё, конец, некуда уменьшать
2$:             tstb    (R1)+           ; сперва пропустим ненулевые байты
                bne     2$
                dec     R1
3$:             tstb    (R1)+           ; потом - нулевые
                beq     3$
                dec     R1
                br      1$              ; и повторим

4$:             mov     (R1)+, R0
                add     @#BAZVP, R0     ; прибавим адрес начала информационной части экрана
                bpl     5$
                sub     #40000, R0      ; если надо - скорректируем
5$:             mov     R0, @#AS        ; получим адрес курсора в ОЗУ, и поместим его на место
                emt     20
                pop     R1
                pop     R0
6$:             pop     R5
                rti
; ───────────────────────────────────────────────────────────────────────────
word_10166:     .word 0
word_10170:     .word 0
word_10172:     .word 0
word_10174:     .word 0
                .byte 0
                .byte 0
SNDLogBuffPtr:  .word 40000     ;указатель в буфере лога передатчика, под это выделена целая страница памяти.
word_10202:     .word 0

TRPRES:         .word 42472             ; trap 0
                .asciz "OFF"            ; опция Echo off
                .even
                .word 42472             ; trap 1
                .asciz "ON "            ; опция Echo on
                .even
                .word 43672             ; trap 2
                .asciz "OFF"            ; опция ANSI off
                .even
                .word 43672             ; trap 3
                .asciz "ON "            ; опция ANSI on
                .even
                .word 52050             ; trap 4
                .asciz ""
                .even
                .word 53250             ; trap 5
                .asciz ""
                .even
                .word 54447             ; trap 6
                .asciz ""
                .even
                .word 55650             ; trap 7
                .asciz ""
                .even
                .word 57050             ; trap 10
                .asciz ""
                .even
                .word 60247             ; trap 11
                .asciz ""
                .even
                .word 61447             ; trap 12
                .asciz ""
                .even
                .word 62650             ; trap 13
                .asciz ""
                .even
                .word 64050             ; trap 14
                .asciz ""
                .even
                .word 62650             ; trap 15
                .asciz "Receive's aborted "
                .even
                .word 64050             ; trap 16
                .byte 277,277,277,277,277,277,277,277,277,277,0
                .even
                .word 62650             ; trap 17
                .asciz "Bad CRC-16 !"
                .even
                .word 62650             ; trap 20
                .asciz "Disk full !"<5>
                .even
                .word 62650             ; trap 21
                .asciz "DIR full !"<7>
                .even
                .word 62650             ; trap 22
                .asciz "Bad HDR !"<10>
                .even
                .word 62650             ; trap 23
                .asciz "Timeout HDR !"<4>
                .even
                .word 62650             ; trap 24
                .asciz "Bad length frame !"
                .even
                .word 62650             ; trap 25
                .asciz "ERROR Timeout !"<3>
                .even
                .word 62650             ; trap 26
                .asciz "ERROR Initialize !"
                .even
                .word 62650             ; trap 27
                .asciz "Initialize OK !"
                .even
                .word 53250             ; trap 30
                .byte 10,10,0
                .even
                .word 55650             ; trap 31
                .byte 10,10,0
                .even
                .word 57050             ; trap 32
                .byte 10,10,0
                .even
                .word 62650             ; trap 33
                .byte 10,10,3,0
                .even
                .word 62650             ; trap 34
                .asciz "Waiting ZFIN !!!"
                .even
                .word 45072             ; trap 35
                .asciz "ON "
                .even
                .word 45072             ; trap 36
                .asciz "OFF"
                .even
                .word 50672             ; trap 37
                .asciz "ON "
                .even
                .word 50672             ; trap 40
                .asciz "OFF"
                .even
                .word 36201             ; trap 41
                .asciz <234>"Term95 x0.07 (c) ED inc. 08-Jun-95"<234>
                .even
                .word 36266             ; trap 42
                .asciz <234>"СТОП-menu"<234>
                .even
                .word 60250             ; trap 43
                .byte 10,10,0
                .even
                .word 61450             ; trap 44
                .byte 10,10,0
                .even
                .word 62650             ; trap 45
                .asciz "Waiting header !"
                .even
                .word 62650             ; trap 46
                .asciz "ERROR synchronize !"
                .even
                .word 62650             ; trap 47
                .asciz "Init receiver  !"
                .even
                .word 62650             ; trap 50
                .asciz "Send's aborted !"
                .even
                .word 62650             ; trap 51
                .asciz "Send's resumed !"
                .even
                .word 62650             ; trap 52
                .asciz "Repeat sending !"
                .even
                .word 50650             ; trap 53
                .asciz "Receiving "
                .even
                .word 50650             ; trap 54
                .asciz "Sending   "
                .even
                .word 52072             ; trap 55
                .asciz "ON "
                .even
                .word 52072             ; trap 56
                .asciz "OFF"
                .even
                .word 53272             ; trap 57
                .asciz "YES"
                .even
                .word 53272             ; trap 60
                .asciz "NO "
                .even
MainMenu:       .ascii <237>"T"<237>"erminal"<12>
                .ascii <237>"E"<237>"cho"<12>
                .ascii <237>"A"<237>"NSI"<12>
                .ascii "autoD"<237>"L"<12>
                .ascii "U"<237>"pload"<12>
                .ascii <237>"D"<237>"ownload"<12>
                .ascii <237>"C"<237>"opyscr"<12>
                .ascii <237>"X"<237>"on/Xoff"<12>
                .ascii <237>"N"<237>"ew IRPS"<12>
                .ascii <237>"Q"<237>"uit to DOS"
                .even

DownloadWndText:.ascii "         File "<12>
                .ascii "Protocol    : Zmodem"<12>
                .ascii "FileName    :"<12>
                .ascii "Elapsed Time: 00:00:00"<12>
                .ascii "FileSize    :"<7><12>
                .ascii "Byte count  :"<7><12>
                .ascii "Average CPS :"<7><12>
                .ascii "Corrections :"<7><12>
                .ascii "Last message:"<7><12>
                .ascii "Progress    : "
                .byte 277,277,277,277,277,277,277,277,277,277,0
                .even

                ; Матрица символов с кодами 200..237
CHR200$237:     .byte 0,0,10,0,76,0,10,0,0,0
                .byte 24,24,24,367,0,377,0,0,0,0,0,0
                .byte 44,146,377,146,44,0,0,0,0,0,0,37
                .byte 20,27,24,24,24,24,24,24,24,27,20,27
                .byte 24,24,24,24,24,24,24,364,4,364,24,24
                .byte 24,24,24,24,24,364,4,374,0,0,0,0
                .byte 0,0,0,0,37,24,24,24,24,24,0,0
                .byte 0,0,0,377,377,377,377,377,360,360,360,360
                .byte 360,360,360,360,360,360,0,0,0,374,4,364
                .byte 24,24,24,24,0,0,0,377,0,367,24,24
                .byte 24,24,0,0,0,370,10,370,10,10,10,10
                .byte 377,377,377,377,377,377,377,377,377,377,0,76
                .byte 101,125,101,135,111,101,76,0,0,0,46,31
                .byte 0,46,31,0,0,0,24,24,24,24,27,24
                .byte 24,24,24,24,104,21,104,21,104,21,104,21
                .byte 104,21,24,24,24,367,0,367,24,24,24,24
                .byte 14,22,2,14,22,22,14,20,22,14,17,17
                .byte 17,17,17,17,17,17,17,17,0,0,0,0
                .byte 374,24,24,24,24,24,10,10,10,370,10,370
                .byte 0,0,0,0,0,0,0,34,76,76,76,34
                .byte 0,0,377,377,377,377,377,0,0,0,0,0
                .byte 24,24,24,27,20,37,0,0,0,0,10,10
                .byte 10,17,10,17,0,0,0,0,0,0,0,17
                .byte 10,17,10,10,10,10,0,0,0,34,42,42
                .byte 42,34,0,0,24,24,24,24,364,24,24,24
                .byte 24,24,252,125,252,125,252,125,252,125,252,125
                .byte 314,63,314,63,314,63,314,63,314,63,314,63

; таблица перекодировки
byte_12416:     .byte 012,216,000,242,270,264,251,007,010,011,012,000,014,015,000,000
                .byte 000,000,202,000,240,223,000,000,263,255,261,276,040,010,032,037
                .byte 040,041,042,043,044,045,046,047,050,051,052,053,054,055,056,057
                .byte 060,061,062,063,064,065,066,067,070,071,072,073,074,075,076,077
                .byte 100,101,102,103,104,105,106,107,110,111,112,113,114,115,116,117
                .byte 120,121,122,123,124,125,126,127,130,131,132,133,134,135,136,137
                .byte 140,141,142,143,144,145,146,147,150,151,152,153,154,155,156,157
                .byte 160,161,162,163,164,165,166,167,170,171,172,173,174,175,176,030
                .byte 341,342,367,347,344,345,366,372,351,352,353,354,355,356,357,360
                .byte 362,363,364,365,346,350,343,376,373,375,377,371,370,374,340,361
                .byte 301,302,327,307,304,305,326,332,311,312,313,314,315,316,317,320
                .byte 277,236,221,267,260,244,220,207,233,204,257,203,231,271,232,243
                .byte 246,241,253,245,265,256,275,235,206,212,201,213,205,247,222,274
                .byte 254,250,273,246,226,214,225,266,272,271,252,215,210,224,211,230
                .byte 322,323,324,325,306,310,303,336,333,335,337,331,330,334,300,321
                .byte 075,053,076,074,267,267,200,217,234,227,227,122,116,044,177,040

; таблица перекодировки
byte_13016:     .byte 000,001,002,003,004,005,006,007,010,011,015,013,014,012,016,017
                .byte 020,021,022,023,024,025,026,027,010,034,036,033,034,035,036,037
                .byte 040,041,042,043,044,045,046,047,050,051,052,053,054,055,056,057
                .byte 060,061,062,063,064,065,066,067,070,071,072,073,074,075,076,077
                .byte 100,101,102,103,104,105,106,107,110,111,112,113,114,115,116,117
                .byte 120,121,122,123,124,125,126,127,130,131,132,133,134,135,136,137
                .byte 140,141,142,143,144,145,146,147,150,151,152,153,154,155,156,157
                .byte 160,161,162,163,164,165,166,167,170,171,172,173,174,175,176,010
                .byte 366,312,334,273,271,307,310,371,367,336,311,313,324,333,001,370
                .byte 266,262,316,025,335,326,276,267,337,274,270,325,022,314,261,260
                .byte 024,301,003,277,265,303,300,315,321,006,332,302,320,031,305,272
                .byte 264,033,316,030,005,304,327,263,004,331,330,322,317,306,032,261
                .byte 356,240,241,346,244,245,344,243,345,250,251,252,253,254,255,256
                .byte 257,357,160,341,342,343,246,242,354,353,247,350,355,351,347,352
                .byte 236,200,201,226,204,205,224,203,225,210,211,212,213,214,110,216
                .byte 217,237,220,103,222,223,206,202,234,233,207,230,235,231,227,232
                .byte 0
                .byte 0
;какая-то таблица, может для подсчёта CRC
word_13420:     .word 0,10041,20102,30143
                .word 40204,50245,60306,70347
                .word 100410,110451,120512,130553
                .word 140614,150655,160716,170757
                .word 11061,1020,31163,21122
                .word 51265,41224,71367,61326
                .word 111471,101430,131573,121532
                .word 151675,141634,171777,161736
                .word 22142,32103,2040,12001
                .word 62346,72307,42244,52205
                .word 122552,132513,102450,112411
                .word 162756,172717,142654,152615
                .word 33123,23162,13021,3060
                .word 73327,63366,53225,43264
                .word 133533,123572,113431,103470
                .word 173737,163776,153635,143674
                .word 44304,54345,64206,74247
                .word 4100,14141,24002,34043
                .word 144714,154755,164616,174657
                .word 104510,114551,124412,134453
                .word 55365,45324,75267,65226
                .word 15161,5120,35063,25022
                .word 155775,145734,175677,165636
                .word 115571,105530,135473,125432
                .word 66246,76207,46344,56305
                .word 26042,36003,6140,16101
                .word 166656,176617,146754,156715
                .word 126452,136413,106550,116511
                .word 77227,67266,57325,47364
                .word 37023,27062,17121,7160
                .word 177637,167676,157735,147774
                .word 137433,127472,117531,107570
                .word 110610,100651,130712,120753
                .word 150414,140455,170516,160557
                .word 10200,241,30302,20343
                .word 50004,40045,70106,60147
                .word 101671,111630,121773,131732
                .word 141475,151434,161577,171536
                .word 1261,11220,21363,31322
                .word 41065,51024,61167,71126
                .word 132752,122713,112650,102611
                .word 172556,162517,152454,142415
                .word 32342,22303,12240,2201
                .word 72146,62107,52044,42005
                .word 123733,133772,103631,113670
                .word 163537,173576,143435,153474
                .word 23323,33362,3221,13260
                .word 63127,73166,43025,53064
                .word 154514,144555,174416,164457
                .word 114710,104751,134612,124653
                .word 54104,44145,74006,64047
                .word 14300,4341,34202,24243
                .word 145575,155534,165477,175436
                .word 105771,115730,125673,135632
                .word 45165,55124,65067,75026
                .word 5361,15320,25263,35222
                .word 176456,166417,156554,146515
                .word 136652,126613,116750,106711
                .word 76046,66007,56144,46105
                .word 36242,26203,16340,6301
                .word 167437,177476,147535,157574
                .word 127633,137672,107731,117770
                .word 67027,77066,47125,57164
                .word 27223,37262,7321,17360

byte_14510:     .byte 00,00,01,02,03,03,04,05,06,06     ; номер байта в строке для 80 симв. в строке
                .byte 07,10,11,11,12,13,14,14,15,16
                .byte 17,17,20,21,22,22,23,24,25,25
                .byte 26,27,30,30,31,32,33,33,34,35
                .byte 36,36,37,40,41,41,42,43,44,44
                .byte 45,46,47,47,50,51,52,52,53,54
                .byte 55,55,56,57,60,60,61,62,63,63
                .byte 64,65,66,66,67,70,71,71,72,73
                .byte 74,74,75,76

byte_14634:     .byte 7,1,3,5,7,1,3,5,7,1 ; адрес маски отсечения для 80 символов в строке
                .byte 3,5,7,1,3,5,7,1,3,5 ; а ещё это смещение, поэтому значения нечётные
                .byte 7,1,3,5,7,1,3,5,7,1
                .byte 3,5,7,1,3,5,7,1,3,5
                .byte 7,1,3,5,7,1,3,5,7,1
                .byte 3,5,7,1,3,5,7,1,3,5
                .byte 7,1,3,5,7,1,3,5,7,1
                .byte 3,5,7,1,3,5,7,1,3,5
                .byte 7,1,3,5

word_14760:     .word 7700              ; маска отсечения для 80 символов в строке
                .word 1760
                .word 374
                .word 77

; ───────────────────────────────────────────────────────────────────────────
CheckAutoDL:    tst     (PC)+
AutoDLCatchFlag:.word 0
                bne     3$
                cmpb    #'r, R0
                beq     1$
                return

1$:             mov     #byte_23443, R5
2$:             com     AutoDLCatchFlag
                br      4$

3$:             mov     word_15036, R5
                cmpb    R0, (R5)+
                bne     2$
                tstb    (R5)
                beq     DownloadFunc
4$:             mov     R5, (PC)+
word_15036:     .word 0
                return

; ───────────────────────────────────────────────────────────────────────────
DownloadFunc:   clr     AutoDLCatchFlag
                call    PrepareIO       ; выводим окошко и настраиваем переменные каталога
                trap    53
                mov     #4, R3
1$:             push    R3
                call    S17176
                pop     R3
                bcs     2$
                cmpb    #4, R0
                beq     3$
                cmpb    #10, R0
                beq     S15166

2$:             jsr     R1, sub_20310
                .byte   6,0,0,0,0
                .even
                call    sub_16760
                sob     R3, 1$
                br      4$

3$:             call    sub_15216
                bcc     S15166
4$:             trap    15

V04$3:          jsr     R1, SendSTRING
                .byte 30,30,30,30,30,30,30,30,30,30,10,10,10,10,10,10,10,10,10,10,0
                .even

; ───────────────────────────────────────────────────────────────────────────
S15166:         mov     #VEC04, @#4
                call    CloseOpenWindow
                jsr     R1,@TXT
                .byte 7,7,7,7,7,7,7,7,7,7,7,0
                .even
                jmp     Process

; ───────────────────────────────────────────────────────────────────────────
sub_15216:      call    sub_15426
                bcc     1$
                cmpb    #5, R0
                beq     3$

1$:             mfps    -(SP)
                jsr     R5, PUSHAR
                mov     #26000, @#177716
                clr     R5
                com     R5
                call    sub_17056
                mov     #16000, @#177716
                mov     DIR, R3
                emt     226             ; Поиск файла в каталоге
                                        ; Вход:  R3 - адрес буфера каталога
                                        ;        @#NAM - адрес блока параметров EMT36
                                        ; Выход: R3 - адрес записи о файле, или бит C если файл не найден
                mov     FileBlkLength, R0
                cmp     R0, 22(R3)      ; сравним длину в блоках
                bne     2$
                mov     FileLoadAddr, 24(R3) ;адрес
                mov     FileLength, R0
2$:             mov     R0, 26(R3)      ; длина
                emt     242             ; Запись каталога
                call    DriveOff
                jsr     R5, POPAR
                mtps    (SP)+
                bcs     6$
                cmpb    #13, R0
                beq     4$
                cmpb    #10, R0
                bne     5$
                call    sub_20610
                br      5$

3$:             jsr     R1, sub_20310
                .byte 5,0,0,0,0
                .even
4$:             call    S17176
                bcs     6$
                cmpb    #17, R0
                bne     7$
                clr     R0
5$:             tst     (PC)+
6$:             sec
                return

7$:             cmpb    #4, R0
                beq     sub_15216
                br      6$

; ───────────────────────────────────────────────────────────────────────────
sub_15426:      jsr     R5, PUSHAR
                mov     #IOBuffer, R4
                mov     #BPDMAG, R5
                clr     (R5)+   ; чистим блок параметров
                clr     (R5)+
                clr     (R5)+
                mov     #10, R0
                mov     R5, R1
1$:             clr     (R1)+
                sob     R0, 1$
                clr     word_16750
                call    sub_16744
                trap    30
                trap    5

2$:             movb    (R4)+, R0
                tstb    byte_17461
                bne     3$
                emt     264             ; Привести R0 к ЛАТ,ЗАГЛ регистру(корректно)
3$:             emt     16
                movb    R0, (R5)+
                bne     2$
                clr     R1
                clr     R3
                clr     R0
                trap    31
                trap    32
                trap    7

4$:             movb    (R4)+, R0
                beq     6$
                cmpb    #40, R0
                beq     6$
                iot
                mov     #11, R2 ; какие-то таинственные действия
                sub     #60, R0
                mov     R1, R5
5$:             add     R5, R1
                adc     R3
                sob     R2, 5$
                add     R0, R1
                adc     R3
                br      4$

6$:             call    sub_20676
                mov     #FileLoadAddr, R5
                clr     (R5)    ; и ещё какие-то таинственные действия
7$:             movb    (R4)+, R0
                beq     8$
                cmpb    #40, R0
                beq     8$
                sub     #60, R0
                rol     (R5)
                rol     (R5)
                rol     (R5)
                bisb    R0, (R5)
                br      7$

8$:             push    R1
                emt     224             ; Чтение каталога в буфер (@#DIR)
                emt     226             ; Поиск файла в каталоге
                pop     R1
                bcs     9$              ; не нашли - переходим
                tst     24(R3)          ; проверим адрес файла
                bne     12$
                mov     22(R3), FileBlkLength_Fnd
                mov     #FileLength, R1
                mov     26(R3), (R1)
                sub     (R1), FileBlkLength_Fnd
                mov     (R1), FileBlkLength
                mov     20(R3), BklNum_Fnd
                add     (R1), BklNum_Fnd
                asl     (R1)
                swab    (R1)
                clr     2(R1)
                bisb    (R1), 2(R1)
                clrb    (R1)
                br      15$

9$:             mov     @#DIR, R3
                tst     R1
                bne     10$
                com     R1
                emt     320             ; Поиск свободного места по длине в блоках
                br      11$

10$:            push    R1
                emt     320             ; Поиск свободного места по длине в блоках
                pop     R1
11$:            bcc     14$
                tst     R3
                beq     13$
                trap    20
12$:            mov     #5, (SP)
                br      16$

13$:            trap    21
                mov     #-4, (SP)
                br      16$

14$:            mov     R1, FileBlkLength_Fnd
                mov     @#DIR, R4
                mov     R0, BklNum_Fnd
                mov     #FileLength, R0
                clr     (R0)+
                clr     (R0)+
                clr     (R0)+
                emt     322             ; Создание записи о файле по длине в блоках
15$:            clr     word_23460
                call    sub_16676
                clr     (SP)
16$:            jsr     R5, POPAR
                cmp     #5, R0
                bne     17$
                sec
                return

17$:            mov     #12, R3
loc_16074:      jsr     R1, sub_20310
                .byte 11
byte_16101:     .byte 0,0,0,0
                .even

jmp_16106:      call    sub_17610
                bcs     26$
                cmpb    #12, R0
                beq     28$
                cmpb    #6, R0
                bne     18$
                trap    22
                br      27$

18$:            cmp     #-1, R0
                bne     19$
                trap    23
                br      27$

39$:            br      loc_16074

19$:            cmpb    #4, R0
                bne     20$
                jsr     R1, sub_20416
                .word IOBuffer
                .word 1000
                bcs     27$
                br      loc_16074

20$:            cmpb    #5, R0
                bne     22$

21$:            trap    15
                br      25$

22$:            cmpb    #13, R0
                beq     24$
                cmpb    #10, R0
                bne     27$
                mov     #4, R1
                mov     #byte_23375, R2
                mov     #byte_17167, R5
23$:            cmpb    (R2)+, (R5)+
                bne     39$
                sob     R1, 23$
24$:            tst     (PC)+
25$:            sec
                return

26$:            jsr     R1, sub_20310
                .byte 6,0,0,0,0
                .even

27$:            call    sub_16760
                sob     R3, 39$
                br      21$

28$:            mov     #4, R1
                mov     #byte_16101, R2
                mov     #byte_23375, R5
29$:            cmpb    (R2)+, (R5)+
                bne     30$
                sob     R1, 29$
                br      33$

30$:            trap    46
                br      32$

31$:            trap    24

32$:            jsr     R1, sub_23224
                .word byte_23403
                br      27$

33$:            jsr     R1, sub_20416
                .word IOBuffer
                .word 2000
                bcs     31$
                cmp     #-1, R0
                bne     34$
                trap    25
                br      27$

34$:            cmp     #553, R0
                beq     37$
                cmp     #552, R0
                beq     36$
                cmp     #551, R0
                beq     35$
                cmp     #550, R0
                bne     27$
                call    sub_16462
                bcs     25$
                br      38$

35$:            call    sub_16462
                bcs     25$
                br      33$

36$:            call    sub_16462
                bcs     25$
                call    sub_17162
                br      33$

37$:            call    sub_16462
                bcs     25$
                call    sub_17162
38$:            jmp     jmp_16106

; ───────────────────────────────────────────────────────────────────────────
sub_16462:      mov     #12, R3
                mov     word_23460, R1
                beq     9$
                tst     FileBlkLength_Fnd
                blos    8$
                jsr     R5, PUSHAR
                mov     #26000, @#177716
                call    DriveOff
                br      2$

1$:             tstb    XonXofOption
                beq     2$
                jsr     R1, SendSTRING
                .asciz <XON>
                .even
2$:             mov     2(SP), R1
                mov     word_17156, R5
                cmp     #40000, R5
                bne     3$
                mov     BklNum_Fnd, word_17116
3$:             add     R1, R5
                cmp     R5, #100000
                bhi     5$
                sub     R1, R5
                mov     #IOBuffer, R4
4$:             movb    (R4)+, (R5)+
                sob     R1, 4$
                mov     R5, word_17156
                ccc
                br      7$

5$:             clr     R5
                tstb    XonXofOption
                beq     6$
                jsr     R1, SendSTRING
                .asciz <XOFF>
                .even
6$:             call    sub_17056
                bcc     1$
7$:             mov     #16000, @#177716
                jsr     R5, POPAR
                bcc     10$
8$:             sec
9$:             return

10$:            call    S20662
                add     R1, BklNum_Fnd
                add     R1, FileBlkLength
                sub     R1, FileBlkLength_Fnd
                clr     R0
                call    sub_16766

; ███████████████ S U B R O U T I N E ███████████████████████████████████████


sub_16676:      mov     #FileLength, R1
                add     word_23460, (R1)
                adc     2(R1)
                trap    10
                clr     R0
                call    S06310
                mov     #byte_16101, R0
                mov     #byte_17167, R2
                mov     #4, R5
1$:             movb    (R1), (R2)+
                movb    (R1)+, (R0)+
                sob     R5, 1$
                trap    33
; End of function sub_16676


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

sub_16744:      trap    12
                mov     (PC)+, R0
word_16750:     .word 0
                bne     4$
                trap    44
                return

; ───────────────────────────────────────────────────────────────────────────
sub_16760:      inc     word_16750
                br      sub_16744

; ───────────────────────────────────────────────────────────────────────────
sub_16766:      trap    43
                trap    11
                mov     word_6634, R1
                beq     5$
                tst     R0
                beq     1$
                mov     SendCounter, R5
                beq     5$
                clr     SendCounter
                br      2$

1$:             mov     ReceiveCounter, R5
                clr     ReceiveCounter
2$:             clr     word_6634
                clr     R0
3$:             sub     R1, R5
                bmi     4$
                inc     R0
                br      3$

4$:             push    R4
                emt     260             ; Вывод десятичного числа
                pop     R4
5$:             return
; End of function sub_16744


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

sub_17056:      mov     word_17156, R1
                sub     #40000, R1
                tst     R5
                bne     1$
                mov     R1, R0
                bic     #177000, R0
                sub     R0, R1
                push    R0
                push    R1

1$:             asr     R1
                adc     R1
                neg     R1
                mov     (PC)+, R0
word_17116:     .word 0
                mov     #40000, R2
                push    R5
                push    R2
                emt     222             ; Чтение/запись блока (160004 исп.буфер ДОС)
                pop     R2
                pop     R5
                bne     3$
                pop     R1
                pop     R0
                beq     3$
                bcs     3$
2$:             movb    (R1)+, (R2)+
                sob     R0, 2$
3$:             mov     R2, (PC)+
word_17156:     .word 40000
                return
; End of function sub_17056


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

sub_17162:      jsr     R1, sub_20310
                .byte 3
byte_17167:     .byte 0,0,0,0
                .even
                return

; ───────────────────────────────────────────────────────────────────────────
S17176:         clrb    byte_17461
                mov     #4, R0
                movb    R0, byte_17250
                tstb    XonXofOption
                bne     1$
                tstb    NewIRPSOption
                beq     2$
1$:             mov     #6, R0
                clrb    byte_17250
2$:             movb    R0, byte_17252
                jsr     R1, sub_20310
                .byte 1
                .byte 0
byte_17250:     .byte 4
                .byte 0
byte_17252:     .byte 4
                .even
                mov     #14, R3

loc_17260:      trap    45
                call    sub_17610
                bcs     8$
                trap    33
                tstb    R0
                beq     S17176
                cmpb    #4, R0
                bne     11$
                trap    43
                jsr     R1, sub_20416
                .word IOBuffer
                .word 1000
                bcs     loc_17342
                cmp     #553, R0
                bne     loc_17342
                mov     #4, R0

loc_17332:      trap    33
                tst     (PC)+
loc_17336:      sec
                return

loc_17342:      trap    26

8$:             cmp     #-1, R0
                beq     loc_17332

loc_17352:      jsr     R1, sub_20310
                .byte 6,0,0,0,0
                .even
                br      loc_17366

loc_17366:      call    sub_16760
                sob     R3, loc_17260
                br      loc_17336

11$:            cmpb    #2, R0
                bne     14$
                jsr     R1, sub_20416
                .word byte_23403
                .word 40
                bcs     loc_17352
                cmp     #553, R0
                bne     loc_17342
                mov     #byte_22565, R1
                mov     #byte_23375, R2
                mov     #3, R0
12$:            cmpb    (R1)+, (R2)+
                bne     13$
                sob     R0, 12$
                comb    byte_17461
13$:            jsr     R1, sub_20310
                .byte 3
                .byte 1
                .byte 0
byte_17461:     .byte 377
                .byte 0
                .even
                trap    27
                br      loc_17260

14$:            cmpb    #21, R0
                bne     15$
                jsr     R1, sub_20310
                .byte 3,0,0,0,0
                .even
                br      loc_17260

15$:            cmpb    #22, R0
                bne     16$
                mov     #12, R3
                jsr     R1, sub_20416
                .word IOBuffer
                .word 1000
                cmp     #553, R0
                bne     loc_17342
                jsr     R1, sub_20310
                .byte 17,0,0,0,0
                .even
                call    sub_17610
                br      17$

16$:            cmpb    #17, R0
                beq     loc_17342
                cmpb    #10, R0
                bne     loc_17366

17$:            call    sub_20610
                mov     #17, R0
                br      loc_17332

; ███████████████ S U B R O U T I N E ███████████████████████████████████████

sub_17610:      push    R3
                mov     #2400., R3
1$:             call    S04252
                bcs     12$
                cmpb    #'*, R0
                beq     3$
                cmpb    #152, R0 ; 'j'
                beq     3$
2$:             sob     R3, 1$
                br      11$

3$:             call    S04252
                bcs     12$
                cmpb    #'*, R0
                beq     3$
                cmpb    #30, R0
                bne     2$
                call    S04252
                bcs     12$
                clrb    byte_1020
                cmpb    #'A, R0
                beq     4$
                cmpb    #'B, R0
                bne     12$
                comb    byte_1020
4$:             mov     #byte_23374, R5
                mov     R5, R1
                mov     #7, R0
                mov     R0, R2
5$:             clrb    (R1)+
                sob     R0, 5$

6$:             mov     #2, R1
                tstb    byte_1020
                bne     7$
                dec     R1
7$:             call    sub_20066
                call    sub_23154
                tst     R1
                bne     7$
                sob     R2, 6$
                mov     #byte_23374, R1
                mov     #5, R5
                call    S04164
                mov     #byte_23403, R5
                mov     #word_4250, R1
                cmpb    (R1)+, -(R5)
                bne     8$
                cmpb    (R1)+, -(R5)
                beq     9$
8$:             trap    17
                br      12$

9$:             tstb    byte_1020
                beq     10$
                call    S04330
                cmpb    #15, R0
                bne     12$
                call    S04330
                call    S04336
                .word 1
                bcs     10$
10$:            movb    byte_23374, R0
11$:            tst     (PC)+
12$:            sec
                pop     R3
                return
; End of function sub_17610

; ───────────────────────────────────────────────────────────────────────────
sub_20066:      call    S04330
                bcs     6$
                cmpb    #21, R0
                beq     sub_20066
                cmpb    #23, R0
                beq     sub_20066
                cmpb    #30, R0
                bne     5$
                call    S04330
                bcs     6$
                cmpb    #30, R0
                beq     1$
                cmpb    #'h, R0
                bhi     2$
                cmpb    #'l, R0
                blos    2$
1$:             bis     #400, R0
                br      5$

2$:             cmpb    #'l, R0
                bne     3$
                mov     #177, R0 ; ''
                br      5$

3$:             cmpb    #'m, R0
                bne     4$
                mov     #377, R0
                br      5$

4$:             bitb    #100, R0
                beq     6$
                bitb    #40, R0
                bne     6$
                bicb    #100, R0
5$:             tst     (PC)+
6$:             sec
                return

; ███████████████ S U B R O U T I N E ███████████████████████████████████████
;вывод байта в 16-ричной форме
;вход: R0 - байт
sub_20226:      push    R1
                push    R0
                mov     #2, R1
1$:             clr     R0
                rolb    (SP)
                rolb    R0
                rolb    (SP)
                rolb    R0
                rolb    (SP)
                rolb    R0
                rolb    (SP)
                rolb    R0
                add     #'0, R0
                cmpb    #'9, R0
                bhis    2$
                add     #47, R0
2$:             call    SendCHAR
                sob     R1, 1$
                pop     R0
                pop     R1
                return
; End of function sub_20226

; ───────────────────────────────────────────────────────────────────────────
sub_20310:      jsr     R1, SendSTRING
                .asciz "**"<30>"B"
                .even
                mov     #5, R5
                call    S04164
1$:             movb    (R1)+, R0
                call    sub_20226
                sob     R5, 1$
                mov     word_4250, R0
                push    R0
                swab    R0
                call    sub_20226
                pop     R0
                call    sub_20226
                jsr     R1, SendSTRING
                .asciz <15><12>
                .even
                movb    -5(R1), R0
                cmpb    #10, R0
                beq     2$
                cmpb    #3, R0
                beq     2$
                jsr     R1, SendSTRING
                .asciz <21>
                .even
2$:             inc     R1
                rts     R1

; ───────────────────────────────────────────────────────────────────────────
sub_20416:      push    R3
                push    R2
                mov     (R1)+, R2
                mov     (R1)+, R3
                push    R1
                inc     R3
                clr     word_4250
                clr     word_23460

1$:             call    sub_20066
                bcs     7$
                bit     #177400, R0
                beq     8$
2$:             cmp     #550, R0
                bhi     5$
                cmp     #554, R0
                blos    5$
                mov     R0, R5
                mov     #2, R1
                movb    R0, R0
                clr     R2
                call    S04134
3$:             call    sub_20066
                bit     #177400, R0
                bne     2$
                swab    R2
                bisb    R0, R2
                sob     R1, 3$
                cmp     word_4250, R2
                beq     4$
                trap    17
                br      7$

4$:             mov     R5, R0
                br      6$

5$:             cmp     #430, R0
                bne     7$
                mov     #20, R0
6$:             tst     (PC)+
7$:             sec
                pop     R1
                pop     R2
                pop     R3
                rts     R1

8$:             movb    R0, (R2)+
                call    S04134
                inc     word_23460
                sob     R3, 1$
                br      7$

; ───────────────────────────────────────────────────────────────────────────
sub_20610:      mov     #4, R3
                jsr     R1, sub_20310
                .byte 10,0,0,0,0
                .even
                trap    34
1$:             call    S04336
                .word 1
                bcs     3$
                cmpb    #'O, R0
                bne     2$
                call    S04336
                .word 1
                return

2$:             tstb    R0
                bmi     3$
                sob     R3, 1$
3$:             return

; ███████████████ S U B R O U T I N E ███████████████████████████████████████
;преобразование длины в байтах в дину в блоках
S20662:         add     #777, R1
sub_20666:      clrb    R1
                swab    R1
                asr     R1
                return
; End of function sub_20666


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

sub_20676:      add     #777, R1
                adc     R3
sub_20704:      call    sub_20666
                bit     #177400, R3
                beq     3$
2$:             dec     R3
                bmi     4$
                add     #200, R1
                br      2$

3$:             swab    R3
                asr     R3
                add     R3, R1
4$:             return
; End of function sub_20676

; ───────────────────────────────────────────────────────────────────────────

UploadFunc:     call    PrepareIO
                trap    54
jmp_20746:      mov     @#DIR, R3
                mov     30(R3), R1      ;Количество файлов в каталоге (НЕ ЗАПИСЕЙ!);
                add     #450, R3        ;переходим к началу записей
1$:             add     #30, R3         ;переходим к следующей записи
                cmpb    #377, (R3)
                beq     1$
                tst     22(R3)
                bmi     3$
                sob     R1, 1$
                jsr     R1, sub_23074
                .byte 10,0,0,0,0
                .even
                trap    34
                call    sub_17610
                bcs     2$
                jsr     R1, SendSTRING
                .asciz "OO"
                .even
2$:             call    S15166
3$:             push    R3
                call    sub_22370
                pop     R3
                bcc     4$
                trap    50
                br      2$

4$:             mov     R3, word_22174
                clr     word_16750
                call    sub_16744
                trap    30
                trap    5
                tst     (R3)+
                mov     #16, R1
                add     R1, R3
                push    R3

5$:             dec     R1
                bmi     2$
                cmpb    #40, -(R3) ; ' '
                bhis    5$
                sub     R1, R3
                inc     R1
                mov     #byte_23464, R5
6$:             movb    (R3)+, R0
                emt     262             ; Замена управляющих кодов в R0 на пробелы
                iot
                tstb    byte_17461
                bne     7$
                emt     264             ; Привести R0 к ЛАТ,ЗАГЛ регистру(корректно)
                bisb    #40, R0
7$:             movb    R0, (R5)+
                sob     R1, 6$
                clrb    (R5)+
                pop     R3
                mov     #FileBlkLength, R1
                clr     -(R1)
                clr     -(R1)
                mov     (R3)+, BklNum_Fnd
                mov     (R3)+, (R1)
                bic     #100000, (R1)
                mov     (R1), FileBlkLength
                dec     FileBlkLength
                asl     (R1)
                swab    (R1)
                bisb    (R1), 2(R1)
                clrb    (R1)
                mov     2(R3), R0
                bic     #177000, R0
                beq     8$
                sub     #1000, (R1)
                sbc     2(R1)
                add     R0, (R1)
                adc     2(R1)
                br      9$

8$:             add     #1000, R0
9$:             mov     R0, word_23460
                trap    31
                trap    32
                trap    7
                mov     R5, R0
                call    S06310
10$:            tstb    (R5)+
                bne     10$
                movb    #40, -(R5)
                inc     R5
                mov     (R3), R1
                mov     #6, R2
                clr     R0
                br      12$

11$:            clr     R0
                rol     R1
                rol     R0
                rol     R1
                rol     R0
12$:            rol     R1
                rol     R0
                add     #'0, R0
                movb    R0, (R5)+
                sob     R2, 11$
                clrb    (R5)+
                sub     #byte_23464, R5
                mov     R5, word_21414
                br      loc_21374

loc_21370:      call    sub_16760
loc_21374:      jsr     R1, sub_23074
                .byte 4,0,0,0,0
                .even
                jsr     R2, sub_23012
                .word byte_23464
word_21414:     .word 0
                .word 153

15$:            call    sub_17610
                bcs     loc_21370
                cmpb    #1, R0
                bne     16$
                call    S04336
                .word 5
                bcs     loc_21370
                cmpb    #'*, R0
                beq     15$
                br      loc_21370

16$:            cmpb    #20, R0
                bne     18$
loc_21460:      jmp     jmp_20746

18$:            cmpb    #10, R0
                beq     loc_21460
                cmpb    #7, R0
                beq     loc_21460
                cmpb    #5, R0
                bne     19$
                jmp     jmp_22172

19$:            cmpb    #11, R0
                bne     loc_21374
                call    sub_22346
                push    R5
20$:            movb    (R2), (R3)+
                movb    (R2)+, (R5)+
                sob     R1, 20$
                tst     -(R5)
                bne     21$
                tst     -(R5)
                beq     22$
21$:            trap    51
22$:            pop     R1
                trap    10
                clr     R0
                call    S06310
                clr     SendCounter
                clr     word_6634
                clr     word_21716
                br      25$

loc_21574:      call    sub_22210
                bcs     loc_21460
                cmpb    #11, R0
                beq     25$
                cmp     #-1, R0
                beq     25$
                cmpb    #3, R0
                beq     25$
                br      loc_21460

loc_21626:      call    sub_16760
25$:            jsr     R1, SendSTRING
                .asciz <21>
                .even
                jsr     R1, sub_23074
                .byte 12
byte_21643:     .byte 0,0,0,0
                .even

loc_21650:      mov     #-1, R0
                call    sub_16766
                trap    10
                mov     #FileLength, R1
                clr     R0
                call    S06310
                mov     R1, R0
                mov     (R0)+, R1
                mov     (R0), R3
                call    sub_20704
                mov     R1, R0
                cmp     R0, FileBlkLength
                blo     27$
                com     (PC)+
word_21716:     .word 0
                mov     word_23460, R1
                br      28$

27$:            mov     #1000, R1
28$:            mov     R1, word_22022
                asr     R1
                adc     R1
                mov     #IOBuffer, R2
                add     BklNum_Fnd, R0
                push    R4
                emt     222             ; Чтение/запись блока (160004 исп.буфер ДОС)
                pop     R4
                mov     #word_22024, R1
                mov     #'h, (R1)
                tst     word_21716
                bne     29$
                mov     #'k, (R1)
                tst     word_22522
                beq     29$
                mov     #'i, (R1)

29$:            jsr     R2, sub_23012
                .word IOBuffer
word_22022:     .word 1000
word_22024:     .word 153
                trap    33
                tst     word_21716
                bne     32$
30$:            cmp     R4, RCVBuffPtr
                beq     31$
                call    S04330
                cmpb    #'*, R0
                beq     loc_21574
                br      30$

31$:            tst     word_22522
                beq     loc_21574
                mov     #FileLength, R5
                add     #1000, (R5)+
                adc     (R5)
                br      loc_21650

32$:            call    sub_22346
                add     word_23460, (R5)
                adc     2(R5)
                mov     #byte_22143, R3
33$:            movb    (R5)+, (R3)+
                sob     R1, 33$
                trap    10
                mov     #FileLength, R1
                clr     R0
                call    S06310
                jsr     R1, sub_23074
                .byte 13
byte_22143:     .byte 0,0,0,0
                .even

34$:            call    sub_22210
                bcs     35$
                cmpb    #3, R0
                beq     34$
                cmpb    #11, R0
                beq     loc_21626
jmp_22172:      mov     (PC)+, R3
word_22174:     .word 120514
                bic     #100000, 22(R3)
35$:            jmp     jmp_20746

; ───────────────────────────────────────────────────────────────────────────
sub_22210:      push    R3
                mov     #12, R3
1$:             call    sub_17610
                bcs     4$
                cmpb    #10, R0
                beq     3$
                cmpb    #7, R0
                beq     3$
                cmpb    #1, R0
                beq     2$
                cmpb    #11, R0
                beq     6$
                cmpb    #3, R0
                beq     6$
                cmpb    #5, R0
                bne     5$
2$:             tst     (PC)+
3$:             sec
                pop     R3
                return

4$:             jsr     R1, sub_23074
                .byte 6,0,0,0,0
                .even
5$:             sob     R3, 1$
                br      3$

6$:             call    sub_22346
7$:             cmpb    (R2)+, (R5)+
                bne     8$
                sob     R1, 7$
                trap    52
8$:             call    sub_22346
9$:             movb    (R2), (R3)+
                movb    (R2)+, (R5)+
                sob     R1, 9$
                br      2$

; ███████████████ S U B R O U T I N E ███████████████████████████████████████


sub_22346:      mov     #byte_23375, R2
                mov     #byte_21643, R3
                mov     #FileLength, R5
                mov     #4, R1
                return
; End of function sub_22346

; ───────────────────────────────────────────────────────────────────────────

sub_22370:      mov     #12, R3
                clrb    byte_17461
                jsr     R1, SendSTRING
                .asciz "rz"<15>
                .even
1$:             jsr     R1, sub_20310
                .byte 0,0,0,0,0
                .even
                call    sub_17610
                bcs     2$
                cmpb    #16, R0
                bne     5$
                jsr     R1, sub_20310
                .byte 3,0,0,0,0
                .even
                br      4$

2$:             cmp     #-1, R0
                bne     3$
                trap    25
                br      4$

3$:             jsr     R1, sub_20310
                .byte 6,0,0,0,0
                .even
4$:             sob     R3, 1$
                br      13$

5$:             cmpb    #22, R0
                beq     4$
                tstb    R0
                beq     4$
                cmpb    #1, R0
                bne     2$
                clr     (PC)+
word_22522:     .word 0
                bitb    #2, byte_23400
                beq     7$
                tstb    XonXofOption
                bne     6$
                tstb    NewIRPSOption
                beq     7$
6$:             com     word_22522
7$:             mov     #12, R3
loc_22560:      jsr     R1, sub_23074
byte_22564:     .byte 2
byte_22565:     .byte 102
                .byte 113
                .byte 132
byte_22570:     .byte 0
                .even
                jsr     R2, sub_23012
                .word byte_22570
                .word 1
                .word 153
8$:             call    sub_17610
                bcc     10$
                jsr     R1, sub_23074
                .byte 6,0,0,0,0
                .even
9$:             sob     R3, loc_22560
                br      13$

10$:            cmpb    #3, R0
                beq     11$
                cmpb    #1, R0
                bne     9$
                call    S04336
                .word 5
                bcs     9$
                cmpb    #'*, R0
                beq     8$
                br      9$

11$:            cmpb    #377, byte_23377
                bne     12$
                comb    byte_17461
12$:            tst     (PC)+
13$:            sec
                return

; ───────────────────────────────────────────────────────────────────────────
sub_22704:      push    R1
                mov     #100, R1
                cmpb    #15, R0
                beq     1$
                cmpb    #215, R0
                bne     2$
1$:             cmpb    word_23002, R1
                bne     4$
2$:             cmpb    #21, R0
                beq     3$
                cmpb    #221, R0
                beq     3$
                cmpb    #23, R0
                beq     3$
                cmpb    #223, R0
                beq     3$
                cmpb    #30, R0
                bne     4$
3$:             jsr     R1, SendSTRING
                .asciz  <30>
                .even
                xor     R1, R0
4$:             movb    R0, (PC)+
word_23002:     .word 0
word_23004:     call    SendCHAR
                pop     R1
                return

; ───────────────────────────────────────────────────────────────────────────
sub_23012:      push    R1
                push    R5
                mov     (R2)+, R1
                mov     (R2)+, R5
                mov     (R2)+, R0
                movb    R0, byte_23053
                call    S04164
                call    S04134
1$:             dec     R5
                bmi     2$
                movb    (R1)+, R0
                call    sub_22704
                br      1$

2$:             jsr     R1, SendSTRING
                .byte 30
byte_23053:     .byte 153
                .byte 0
                .even
                call    sub_23130
                jsr     R1, SendSTRING
                .asciz  <21>
                .even
                pop     R5
                pop     R1
                rts     R2

; ───────────────────────────────────────────────────────────────────────────
sub_23074:      jsr     R1, SendSTRING
                .asciz "*"<30>"A"
                .even
                mov     #5, R5
                call    S04164
1$:             movb    (R1)+, R0
                call    sub_22704
                sob     R5, 1$
                call    sub_23130
                inc     R1
                rts     R1

; ███████████████ S U B R O U T I N E ███████████████████████████████████████

sub_23130:      mov     word_4250, R0
                swab    R0
                call    sub_22704
                mov     word_4250, R0
                call    sub_22704
locret_23152:   return
; End of function sub_23130


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
;преобразовываем символ в 16ричном виде в число
;вход:  R0 - символ
;       R1 - длина числа в символах
;       R5 - буфер, где формируется число
sub_23154:      tstb    byte_1020
                beq     3$
                sub     #141, R0 ; 'a'
                bmi     1$
                add     #12, R0
                br      2$

1$:             add     #61, R0 ; '1'
2$:             ccc
                rolb    (R5)
                rolb    (R5)
                rolb    (R5)
                rolb    (R5)
3$:             bisb    R0, (R5)
                sob     R1, locret_23152
                inc     R5
                return
; End of function sub_23154


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

sub_23224:      mov     (R1)+, R5
1$:             movb    (R5)+, R0
                bne     2$
                rts     R1

2$:             cmpb    #335, R0
                beq     1$
                cmpb    #336, R0
                beq     3$
                call    SendCHAR
                br      1$

3$:             cmpb    #31, word_6632
                bhis    3$
                mov     #1, word_6636
4$:             tst     word_6636
                bne     4$
                br      1$
; End of function sub_23224

; ───────────────────────────────────────────────────────────────────────────
PrepareIO:      mov     #V04$3, @#4
                mov     #36000, @#177716
                call    ClrScr
                mov     #16000, @#177716
                call    sub_EscCode163      ; cmd s
                call    DrawWindow
                .word   47430
                .word   44
                .word   170
                call    DrawScrText
                .word   DownloadWndText
                .word   1200
                emt     216                 ; Инициализация драйвера дисковода
                movb    @#DEVTEK, 34(R3)    ; Номер текущего устройства
                movb    @#SUBTEK, @#SUBDIR  ; Номер подкаталога на тек. диске -> Подкаталог для CREATE, временн.
                mov     @#LD0, @#LD1        ; Смещение к логическому диску (в блоках), 0 - корень -> то же, но для текущей операции
                return
; ───────────────────────────────────────────────────────────────────────────
byte_23374:     .byte   0
byte_23375:     .byte   0
                .byte   0
byte_23377:     .byte   0
byte_23400:     .byte   0
                .byte   0
                .byte   0
byte_23403:     .blkb   40

byte_23443:     .byte   172,15
                .even

FileLength:     .word   0,0
FileBlkLength:  .word   0
FileBlkLength_Fnd: .word 0
BklNum_Fnd:     .word   0
word_23460:     .word   0
FileLoadAddr:   .word   1000
byte_23464:     .blkb   52
FreeSpace:


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

OutStr$Prep:
3$:             movb    (R1)+, R0       ; Выводим текст
                beq     1$
                emt     16
                br      3$

1$:             inc     R1
                bic     #1,R1
                rts     R1
; End of function OutStr$Prep

; ───────────────────────────────────────────────────────────────────────────
Prepare:        mov     #VERS, R0       ; Проверим версию МКДОС
                tst     (R0)
                bmi     10$             ; Если это вообще МКДОС, пойдём проверять дальше
11$:            jsr     R1, OutStr$Prep
                .asciz  "Программа работает только в MKDOS V2.34 и выше!"<12>
                .even
                emt     6
                halt                    ; выходим в ОС

10$:            cmpb    #234., (R0)     ; Проверяем версию МКДОС
                blos    11$             ; если меньше 2.34, не работаем
                mov     @#30, V30BUF    ; сохраняем вектор EMT
                mov     #19., R1
                mov     #off_24112, R5  ; массив пар {значение, адрес}

4$:             mov     (R5)+, @(R5)+   ; инициализируем вектора и некоторые переменные
                sob     R1, 4$
                mov     @#424, R0       ; берём откуда-то палитру
                bic     #140000, R0     ; и таймер включаем
                mov     R0, @#177662    ; применяем
                call    ClrScr          ; очистка экрана
                mov     #7, R4          ; рисуем интерфейс
                call    FillScr2
                mov     #42000, R5
                mov     #100, R1
8$:             com     -(R5)
                sob     R1, 8$
                trap    41              ; выводим заголовок проги
                trap    42              ; и подсказку - СТОП-menu
                jsr     R1, @TXT        ; выведем текст через мкдосную п/п TXT
                .asciz  <14>
                .even
                mov     RCVBuffPtr, R4
                tst     @#TTKB
                bis     #100, @#TTKS    ; разрешаем работу по прерыванию
                call    DriveOff        ; прекращаем дисководную активность
                mov     (SP)+, R0       ; подменяем два первых слова проги
                clr     -(R0)           ; чтобы случайно снова на Prepare не перейти
                mov     (PC)+, -(R0)
                .word   400 + /Process - /START$ - 1 ;br Process-START$
                jmp     (R0)            ; и начинаем работу

; массив пар {значение, адрес}
off_24112:      .word VEC04,    4
                .word 100,      6
                .word VEC20,    20
                .word 0,        22
                .word VEC30,    30
                .word 0,        32
                .word VEC34,    34
                .word 0,        36
                .word VEC60,    60
                .word 200,      62
                .word VEC274,   274
                .word 200,      276
                .word 377,      PRGAHK
                .word 0,        word_10172
                .word VEC100,   100
                .word 0,        102
                .word 1330,     177664
                .word VEC360,   TTKINT
                .word 340,      TTKINT+2


                .END
